####################################################################################

global ModName
global ModDesc
global ModVersion
global ModAuthor
global ModAuthorInfo
global NewFiles
global RepFiles
global MakeDirs

####################################################################################
# Mod Info
####################################################################################

# Mod Name
ModName          = "NewOrcCity"
# Mod Description
import Language
if Language.Current == 'Spanish':
	ModDesc = (
		"""This map is a demo for testing playable enemy characters."""
		)
else:
	ModDesc = (
		"""This map is a demo for testing playable enemy characters."""
		)

# Mod Version
ModVersion       = "1.0"
# Author name
ModAuthor        = "ProsperoProductions"
# Author info: email, url,...
ModAuthorInfo    = "peterrobinsonfineart@btinternet.com"

####################################################################################
# Mod Data
####################################################################################

# Make new directories

MakeDirs = ['../NewOrcCity', 
	    '../NewOrcCity/Spanish',
	    '../NewOrcCity/NUFiles',
	    '../NewOrcCity/NUFiles/NUOrkStuff',
	    '../NewOrcCity/NUFiles/NUGoldOrkStuff',
	    '../NewOrcCity/NUFiles/NUDarkOrkStuff',
	    '../NewOrcCity/NUFiles/NUGreatOrkStuff',
	    '../NewOrcCity/NUFiles/NUEricStuff',
	    '../NewOrcCity/NUFiles/NUSuperZoeStuff',
            '../NewOrcCity/ComboScreens/DarkOrc',
            '../NewOrcCity/ComboScreens/Orc',
            '../NewOrcCity/ComboScreens/GoldOrc',
            '../NewOrcCity/ComboScreens/ChiefOrc',
            '../NewOrcCity/pak']
           



#MapName="NewOrcCity"


# New Files added by Mod and destination directory


NewFiles[0]      = {'File': 'NewOrcCity/pj.py'                                       ,	'Dest': '../NewOrcCity'}
NewFiles[1]      = {'File': 'NewOrcCity/SHobjs.py'                                   ,	'Dest': '../NewOrcCity'}
NewFiles[2]      = {'File': 'NewOrcCity/SHenemy.py'                                  ,	'Dest': '../NewOrcCity'}
NewFiles[3]      = {'File': 'NewOrcCity/def_class.py'                                , 	'Dest': '../NewOrcCity'}
NewFiles[4]      = {'File': 'NewOrcCity/DefFuncs.py'                                 ,	'Dest': '../NewOrcCity'}
NewFiles[5]      = {'File': 'NewOrcCity/cfg.py'                                      ,	'Dest': '../NewOrcCity'}
NewFiles[6]      = {'File': 'NewOrcCity/TextureMaterials.py'                         ,	'Dest': '../NewOrcCity'}
NewFiles[7]      = {'File': 'NewOrcCity/PlayerTypes.py'                              ,	'Dest': '../NewOrcCity'}
NewFiles[8]      = {'File': 'NewOrcCity/EnemyCharTypes.py'                           ,	'Dest': '../NewOrcCity'}
NewFiles[9]      = {'File': 'NewOrcCity/NewOrcCity.lvl'                                 ,    'Dest': '../NewOrcCity'}
NewFiles[10]      = {'File': 'NewOrcCity/Blade_progress.jpg'                             ,    'Dest': '../NewOrcCity'}
NewFiles[11]      = {'File': 'NewOrcCity/NewOrcCityMenu/NewOrcCityMenu.py'               ,    'Dest': '../../Scripts'}
NewFiles[12]      = {'File': 'NewOrcCity/NewOrcCityMenu/NewOrcCityMenu.bmp'              ,    'Dest': '../NewOrcCity'}
NewFiles[13]      = {'File': 'NewOrcCity/Positions.py'                                   ,    'Dest': '../NewOrcCity'}
NewFiles[14]      = {'File': 'NewOrcCity/AllyOrkTypes.py'                                ,    'Dest': '../NewOrcCity'}
NewFiles[15]      = {'File': 'NewOrcCity/NewOrcCityMenu/orc.bmp'                 	 ,    'Dest': '../../Data/Icons'}
NewFiles[16]      = {'File': 'NewOrcCity/NewOrcCityMenu/grtork.bmp'                 	 ,    'Dest': '../../Data/Icons'}
NewFiles[17]      = {'File': 'NewOrcCity/NewOrcCityMenu/drkork.bmp'                 	 ,    'Dest': '../../Data/Icons'}
NewFiles[18]      = {'File': 'NewOrcCity/NewOrcCityMenu/gldork.bmp'                 	 ,    'Dest': '../../Data/Icons'}
NewFiles[19]      = {'File': 'NewOrcCity/NUFiles/NUOrkStuff/NUOrkData.py'                ,     'Dest': '../NewOrcCity/NuFiles/NUOrkStuff'}
NewFiles[20]      = {'File': 'NewOrcCity/NUFiles/NUOrkStuff/OrkAnm_def.py'                ,     'Dest': '../NewOrcCity/NuFiles/NUOrkStuff'}
NewFiles[21]      = {'File': 'NewOrcCity/NUFiles/NUOrkStuff/NUOrkCombos.py'              ,     'Dest': '../NewOrcCity/NuFiles/NUOrkStuff'}
NewFiles[22]      = {'File': 'NewOrcCity/NUFiles/NUOrkStuff/NUOrkBAct.py'                ,     'Dest': '../NewOrcCity/NuFiles/NUOrkStuff'}
NewFiles[23]      = {'File': 'NewOrcCity/NUFiles/NUOrkStuff/NUOrkAnimationSet.py'        ,     'Dest': '../NewOrcCity/NuFiles/NUOrkStuff'}
NewFiles[24]      = {'File': 'NewOrcCity/ComboScreens/DarkOrc/combos.jpg'                 ,	'Dest': '../NewOrcCity/ComboScreens/DarkOrc'}
NewFiles[25]      = {'File': 'NewOrcCity/ComboScreens/Orc/combos.jpg'                     ,	'Dest': '../NewOrcCity/ComboScreens/Orc'}
NewFiles[26]      = {'File': 'NewOrcCity/ComboScreens/GoldOrc/combos.jpg'                 ,	'Dest': '../NewOrcCity/ComboScreens/GoldOrc'}
NewFiles[27]      = {'File': 'NewOrcCity/ComboScreens/ChiefOrc/combos.jpg'                ,	'Dest': '../NewOrcCity/ComboScreens/ChiefOrc'}
NewFiles[28]      = {'File': 'NewOrcCity/ComboScreens/credits.jpg'                        ,	'Dest': '../NewOrcCity/ComboScreens'}
NewFiles[29]      = {'File': 'NewOrcCity/NUFiles/XtraAnimSounds.py'                       ,     'Dest': '../NewOrcCity/NUFiles'}
NewFiles[30]      = {'File': 'NewOrcCity/NUFiles/NUGoldOrkStuff/NUGoldOrkData.py'         ,     'Dest': '../NewOrcCity/NUFiles/NUGoldOrkStuff'}
NewFiles[31]      = {'File': 'NewOrcCity/NUFiles/NUGoldOrkStuff/GoldOrkAnm_def.py'        ,     'Dest': '../NewOrcCity/NUFiles/NUGoldOrkStuff'}
NewFiles[32]      = {'File': 'NewOrcCity/NUFiles/NUGoldOrkStuff/NUGoldOrkCombos.py'       ,     'Dest': '../NewOrcCity/NUFiles/NUGoldOrkStuff'}
NewFiles[33]      = {'File': 'NewOrcCity/NUFiles/NUGoldOrkStuff/NUGoldOrkBAct.py'         ,     'Dest': '../NewOrcCity/NUFiles/NUGoldOrkStuff'}
NewFiles[34]      = {'File': 'NewOrcCity/NUFiles/NUGoldOrkStuff/NUGoldOrkAnimationSet.py' ,     'Dest': '../NewOrcCity/NUFiles/NUGoldOrkStuff'}
NewFiles[35]      = {'File': 'NewOrcCity/NUFiles/NUDarkOrkStuff/NUDarkOrkData.py'         ,     'Dest': '../NewOrcCity/NUFiles/NUDarkOrkStuff'}
NewFiles[36]      = {'File': 'NewOrcCity/NUFiles/NUDarkOrkStuff/DarkOrkAnm_def.py'        ,     'Dest': '../NewOrcCity/NUFiles/NUDarkOrkStuff'}
NewFiles[37]      = {'File': 'NewOrcCity/NUFiles/NUDarkOrkStuff/NUDarkOrkCombos.py'       ,     'Dest': '../NewOrcCity/NUFiles/NUDarkOrkStuff'}
NewFiles[38]      = {'File': 'NewOrcCity/NUFiles/NUDarkOrkStuff/NUDarkOrkBAct.py'         ,     'Dest': '../NewOrcCity/NUFiles/NUDarkOrkStuff'}
NewFiles[39]      = {'File': 'NewOrcCity/NUFiles/NUDarkOrkStuff/NUDarkOrkAnimationSet.py' ,     'Dest': '../NewOrcCity/NUFiles/NUDarkOrkStuff'}
NewFiles[40]      = {'File': 'NewOrcCity/NUFiles/NUGreatOrkStuff/NUChiefOrkData.py'         ,     'Dest': '../NewOrcCity/NUFiles/NUGreatOrkStuff'}
NewFiles[41]      = {'File': 'NewOrcCity/NUFiles/NUGreatOrkStuff/ChiefOrkAnm_def.py'        ,     'Dest': '../NewOrcCity/NUFiles/NUGreatOrkStuff'}
NewFiles[42]      = {'File': 'NewOrcCity/NUFiles/NUGreatOrkStuff/NUChiefOrkCombos.py'       ,     'Dest': '../NewOrcCity/NUFiles/NUGreatOrkStuff'}
NewFiles[43]      = {'File': 'NewOrcCity/NUFiles/NUGreatOrkStuff/NUChiefOrkBAct.py'         ,     'Dest': '../NewOrcCity/NUFiles/NUGreatOrkStuff'}
NewFiles[44]      = {'File': 'NewOrcCity/NUFiles/NUGreatOrkStuff/NUChiefOrkAnimationSet.py' ,     'Dest': '../NewOrcCity/NUFiles/NUGreatOrkStuff'}
NewFiles[45]      = {'File': 'NewOrcCity/NUFiles/NUGreatOrkStuff/crk.mmp'                   ,     'Dest': '../NewOrcCity'}
NewFiles[46]      = {'File': 'NewOrcCity/NUFiles/NUOrkStuff/orx.mmp'                        ,     'Dest': '../NewOrcCity'}
NewFiles[47]      = {'File': 'NewOrcCity/NUFiles/NUAnmFact.py'                              ,     'Dest': '../NewOrcCity/NUFiles'}
NewFiles[48]      = {'File': 'NewOrcCity/NUFiles/OrkSoundsX.py'                             ,     'Dest': '../NewOrcCity/NUFiles'}
NewFiles[49]      = {'File': 'NewOrcCity/Shalatuwar.lvl'                                 	,    'Dest': '../NewOrcCity'}
NewFiles[50]      = {'File': 'NewOrcCity/Kashgar.lvl'                                 		,    'Dest': '../NewOrcCity'}
NewFiles[51]      = {'File': 'NewOrcCity/AlFarum.lvl'                                 		,    'Dest': '../NewOrcCity'}
NewFiles[52]      = {'File': 'NewOrcCity/Alobjs.py'                                 		,    'Dest': '../NewOrcCity'}
NewFiles[53]      = {'File': 'NewOrcCity/Alenemies.py'                                 		,    'Dest': '../NewOrcCity'}
NewFiles[54]      = {'File': 'NewOrcCity/Kobjs.py'                                 		,    'Dest': '../NewOrcCity'}
NewFiles[55]      = {'File': 'NewOrcCity/Kenemy.py'                                 		,    'Dest': '../NewOrcCity'}
NewFiles[56]      = {'File': 'NewOrcCity/texobjs.mmp'                                           ,    'Dest': '../NewOrcCity'}
NewFiles[57]      = {'File': 'NewOrcCity/nuslm.mmp'                                             ,    'Dest': '../NewOrcCity'}
NewFiles[58]      = {'File': 'NewOrcCity/ActorsInit.py'                                         ,    'Dest': '../NewOrcCity'}
NewFiles[59]      = {'File': 'NewOrcCity/Armour.py'                                             ,    'Dest': '../NewOrcCity'}
NewFiles[60]      = {'File': 'NewOrcCity/MusicEvents.py'                                        ,    'Dest': '../NewOrcCity'}