import Bladex
import Enm_Def
import Reference
import AllyCombat
import Combat
import AuxTran
import AniSound
import pdb
import BCopy
import math
import whrandom
import Actions
import Interpolator
import CharStats
import ItemTypes
import AuxFuncs
import Sparks
import Objects
import InitDataField
import Blood
import dust
import B3DLib
import Damage
import darfuncs
import GenFX
import OnOff
import DMusic
import ObjStore
import GameText
import Change
import ScorerActions
import Basic_Funcs
import def_class
import Enm_Def
import Ally_Def
import AllyCombat
import EnemyTypes
import Auras
import Sounds
import GameStateAux
import ItemTypes

import Ally_Def
import AllyCombat



TRUE = 1==1
FALSE = not TRUE

############################################################################################################################################################

class AllyOrk (Ally_Def.NPCAlly):

	Helmet=0
	headhitsnd=""
	
	def __init__(self, me):
		# base class init
		Ally_Def.NPCAlly.__init__(self, me)
		# anims
		me.AnmTranFunc=AuxTran.AuxTranOrc

		# Set up orc specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
				
		self.headhitsnd= Bladex.CreateSound ("..\\..\\Sounds\\golpe-arma-escudo.wav","SonidoHeadHit")
		self.headhitsnd.Volume=1
		self.headhitsnd.MinDistance=1000
		self.headhitsnd.MaxDistance=30000
		
		self.HLCFunc = self.StdHLCFunc
		
		
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.Kind=="Ork":
			AniSound.AsignarSonidosOrco(EntityName)
		elif me.Kind=="Great_Ork":
			AniSound.AsignarSonidosOrcoGrande(EntityName)
	
	
		
	# Functions for loading and saving state
	def __getstate__(self):
		# Tiene que devolver cmo poder guardar el estado de la clase
		NPCAlly_state=Ally_Def.NPCAlly.__getstate__(self)
		if(NPCAlly_state[0]!=1):
			print "ERROR: Ork.__getstate__(): Base class version differs."
			# Throw?
			return NPCAlly_state
		NPCAlly_state[1]["AllyOrk"]=(self.Helmet,)

		return NPCAlly_state
		

	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Ally_Def.NPCAlly.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["AllyOrk"]
			self.Helmet=parms[0]
			self.headhitsnd= Bladex.CreateSound ("..\\..\\Sounds\\golpe-arma-escudo.wav","SonidoHeadHit")
			self.headhitsnd.Volume=1
			self.headhitsnd.MinDistance=2000
			self.headhitsnd.MaxDistance=30000
		me=Bladex.GetEntity(self.Name)
		me.AnmTranFunc=AuxTran.AuxTranOrc
		



	def ResetCombat (self,EntityName):
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			me.BlockingPropensity = 0.6
			me.AttackList = BCopy.deepcopy(AllyOrkAttackData)
			self.ChanceOfFuryOnHurt = 0.45
			if self.Invincibility==1:
				self.Invincibility=0
			
			
			
	def StdHLCFunc (self, entityName):
		GameText.WriteTextAux(entityName+":  "+"Arrgh!!! Watch out you daft bugger!",2.0,252,247,167,[],100)
		
		
	def PutOnHelmet(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		if self.Helmet==0:
			if me.Kind in("Chief_Ork","Great_Ork"):
				me.Freeze()
				angle=me.Angle
				pos=me.Position
				me.Position=-44067.7201319,112.334845044,-54448.5055092
				me.Angle=3.4220683
				helm=Bladex.CreateEntity(EntityName+"Helmet","Casco1",-44080.0,-540.0,-54960.0)
				helm.Orientation=(0.701057374477,0.701057374477,-0.0922959670424,0.0922959521413)
				me.LinkToNode(helm, me.GetNodeIndex("Head"))
				me.Angle=angle
				me.Position=pos[0],pos[1],pos[2]
				Bladex.AddScheduledFunc(Bladex.GetTime()+0.1,me.UnFreeze,())
				self.Helmet=1
				
			elif me.Kind=="Ork":
				me.Freeze()
				angle=me.Angle
				me.Angle=1.5
				helm=Bladex.CreateEntity(EntityName+"Helmet","Casco5",0,0,0)
				helm.Scale=1.2
				pos=me.GraspPos("ViewPoint")
				orient=me.Orientation
				helm.Position=pos[0]+180,pos[1],pos[2]-30
				helm.Orientation=orient
				me.LinkToNode(helm, me.GetNodeIndex("Head"))
				me.Angle=angle
				Bladex.AddScheduledFunc(Bladex.GetTime()+0.1,me.UnFreeze,())
				self.Helmet=1
		
		
		

	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		me=Bladex.GetEntity(EntityName)
		if DamageZone==Reference.BODY_HEAD and self.Helmet==1:
			pos=me.Position
			self.headhitsnd.Play(pos[0],pos[1],pos[2],0)
			me.LaunchAnmType("hurt_f_head")
			print EntityName+">>>Ha-ha! I have got my helmet on"
		else:
			Ally_Def.NPCAlly.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
			

		
		
			
AllyOrkAttackData =	[ 
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.25, (),                   500.0, 1000.0, 3000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tf",                 750.0, 1500.0, 3500.0, 0.50],
           # total inner zone 0.45
           
           # outer zone blocks:
            [AllyCombat.BLOCK,  0.07, (),                  3000.0, 4000.0, 5000.0, 0.50],
            [AllyCombat.BLOCK,  0.035,"tr",                3500.0, 7000.0, 9000.0, 0.50,1],
            [AllyCombat.BLOCK,  0.035,"tl",                3500.0, 7000.0, 9000.0, 0.50,1],
            [AllyCombat.BLOCK,  0.245,"tb",                3500.0, 7000.0, 9000.0, 0.50,1],
            [AllyCombat.BLOCK,  0.07, "tf",                3500.0, 7000.0, 9000.0, 0.50,1],
           # total outer zone 0.455
           
           # dodges:
            [AllyCombat.DODGE,  0.30, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.30, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.30, "d_b",                500.0, 1200.0, 2800.0, 0.35],

           # attacks:
        [AllyCombat.ATTACKDOWN, 1.00, ("STAIRS",),         1200.0, 1800.0, 2500.0, 0.35],

            [AllyCombat.ATTACK, 0.50, ("g_01",),            765.0, 2397.5, 3265.0, 0.35],
            [AllyCombat.ATTACK, 0.40, ("g_02",),            873.0, 2123.0, 3373.0, 0.35],
            [AllyCombat.ATTACK, 0.40, ("g_06",),            764.0, 2014.0, 3264.0, 0.35],
            [AllyCombat.ATTACK, 0.20, ("g_15",),            844.0, 2094.0, 3344.0, 0.35],
            [AllyCombat.ATTACK, 0.20, ("g_16",),            243.0, 1493.0, 2743.0, 0.35],
            [AllyCombat.ATTACK, 0.15, ("g_18",),           1917.0, 3167.0, 4417.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1200.0, 1.00,1],
            
            # combinations
            [AllyCombat.ATTACK, 0.40, ("COMBO1",),            764.0, 2014.0, 3264.0, 0.35],
            [AllyCombat.ATTACK, 0.40, ("COMBO2",),            243.0, 1493.0, 2743.0, 0.35],
            [AllyCombat.ATTACK, 0.40, ("COMBO3",),            873.0, 2123.0, 3000.0, 0.35],

           # inner zone moves:
            [AllyCombat.MOVE,   0.03, "tr",                   0.0, 2000.0, 5000.0, 0.50],
            [AllyCombat.MOVE,   0.03, "tl",                   0.0, 2000.0, 5000.0, 0.50],
            [AllyCombat.MOVE,   0.05, "tb",                   0.0, 2000.0, 5000.0, 0.50],
            [AllyCombat.MOVE,   0.10, "tf",                   0.0, 2000.0, 5000.0, 0.50],

           # outer zone moves:
            [AllyCombat.MOVE,   0.03, "tr",                5000.0, 7000.0, 9000.0, 0.50,1],
            [AllyCombat.MOVE,   0.03, "tl",                5000.0, 7000.0, 9000.0, 0.50,1],
            [AllyCombat.MOVE,   0.05, "tb",                5000.0, 7000.0, 9000.0, 0.50,1],
            [AllyCombat.MOVE,   0.03, "tf",                5000.0, 7000.0, 9000.0, 0.50,1],
            [AllyCombat.MOVE,   0.15, AllyCombat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35,1],
            [AllyCombat.MOVE,   0.05, AllyCombat.UsePotion,           3000.0, 7000.0, 9000.0, 1.00],
]
#########################################################################################################################################################


class Super_KntAlly (Ally_Def.NPCAlly):
	def __init__(self, me):
		# base class init
		Ally_Def.NPCAlly.__init__(self, me)
		#print "Personage Creado",me.Name,self.changed_func

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		me.MeshName="KgtSkin2"
	
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosCaballero(EntityName)
		
		
		self.HLCFunc = self.StdHLCFunc
		

	# Functions for loading and saving state
	def __getstate__(self):	
		#print "Changed Funcs",self.changed_func
		
		NPCAlly_state=Ally_Def.NPCAlly.__getstate__(self)
		if(NPCAlly_state[0]!=1):
			print "ERROR: Super_KntAlly.__getstate__(): Base class version differs."
			return NPCAlly_state
		NPCAlly_state[1]["Super_KntAlly"]=()
		return NPCAlly_state
	
	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Ally_Def.NPCAlly.__setstate__(self,parm)

	def ResetCombat (self,EntityName):		
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 1.5
			me.BlockingPropensity = 0.7
			me.AttackList = BCopy.deepcopy(Super_KntAllyAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00

	def StdHLCFunc (self, entityName):
		GameText.WriteTextAux(entityName+":  "+"Hey! Watch out you mad sod!!!",2.0,252,247,167,[],100)

#######################################GM40_1H    #Wrath of the Gods
			
def ExtraAnmForSuper_KntAlly ():

	Aknt=Bladex.GetCharType("Knight_N","Kgt")

	#  Espada romana
	#Bladex.AddBipedAction("Knight_N","g_27kata_new","Kgt_g_27kata_new",0.0,1.0,0)
	#Aknt.AddAttack("GM35_1H","Kgt_g_27kata_new")
	#Aknt.AttackWindow("Kgt_g_27kata_new",0.427,0.670,"GM35_1H_Window")
	#Aknt.AssignTrail("GM35_1H","","EstelaRoja1")
	#Aknt.AddLevels("Kgt_g_27kata_new",7,40)
	#Aknt.AddEnergyLevel("Kgt_g_27kata_new", 0)

	#  Espada elfica
	#Bladex.AddBipedAction("Knight_N","g_32_5_3new","Kgt_g_32_5_3new",0.0,1.0,0)
	#Aknt.AddAttack("GM34_1H","Kgt_g_32_5_3new")
	#Aknt.AttackWindow("Kgt_g_32_5_3new",0.508,0.706,"GM34_1H_Window")
	#Aknt.AssignTrail("GM34_1H","","EstelaRoja1")
	#Aknt.AddLevels("Kgt_g_32_5_3new",8,40)
	#Aknt.AddEnergyLevel("Kgt_g_32_5_3new", 0)

	#  Espada curva
	#Bladex.AddBipedAction("Knight_N","g_sb25_new","Kgt_g_sb25_new",0.0,1.0,0)
	#Aknt.AddAttack("GM5_1H","Kgt_g_sb25_new")
	#Aknt.AttackWindow("Kgt_g_sb25_new",0.472,0.626,"GM5_1H_Window")
	#Aknt.AssignTrail("GM5_1H","","EstelaRoja1")
	#Aknt.AddLevels("Kgt_g_sb25_new",5,40)
	#Aknt.AddEnergyLevel("Kgt_g_sb25_new", 0)
	
	#  Espada Doble
 	Bladex.AddBipedAction("Knight_N","g_22kata_23_new","Kgt_g_22kata_23_new",0.0,1.0,0)
	Aknt.AddAttack("GM40_1H","Kgt_g_22kata_23_new")
 	Aknt.AttackWindow("Kgt_g_22kata_23_new",0.001,0.900,"GM40_1H_Window")
 	Aknt.AssignTrail("GM40_1H","","EstelaRoja1")
 	Aknt.AddLevels("Kgt_g_22kata_23_new",16,40)
	Aknt.AddEnergyLevel("Kgt_g_22kata_23_new", 0)	
	
	
	
Super_KntAllyAttackData = [
	# inner zone blocks:
	[AllyCombat.BLOCK,  0.20, "tr",                 750.0, 1500.0, 3500.0, 0.50],
	[AllyCombat.BLOCK,  0.20, "tl",                 750.0, 1500.0, 3500.0, 0.50],
	[AllyCombat.BLOCK,  0.20, "tb",                 750.0, 1500.0, 3500.0, 0.50],
        [AllyCombat.BLOCK,  0.40, "tf",                 750.0, 1500.0, 3500.0, 0.50],

        # outer zone blocks:
        [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
        [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
        [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
        [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

	# dodges
        [AllyCombat.DODGE,  0.15, "d_r",                0.0, 1200.0, 2800.0, 0.35],
        [AllyCombat.DODGE,  0.15, "d_l",                0.0, 1200.0, 2800.0, 0.35],
        [AllyCombat.DODGE,  0.10, "d_b",                0.0, 1200.0, 2800.0, 0.35],

	# basic attacks
	[AllyCombat.ATTACK, 0.05, ("GI_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light Attack 
	[AllyCombat.ATTACK, 0.05, ("GM1_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light High Attack 
	[AllyCombat.ATTACK, 0.05, ("GM8_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light Low Attack 
	[AllyCombat.ATTACK, 0.05, ("GM6_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light Left Attack 
	[Combat.ATTACK, 0.05, ("GM3_1H",),            1200.0, 1800.0, 2500.0, 0.35],     # Light Right Attack 

        # inner zone moves:
        [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
        [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
        [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
        [AllyCombat.MOVE,   0.15, "tf",                   0.0, 2000.0, 5000.0, 0.35],
    
        #[AllyCombat.ATTACK, 0.12, ("GM40_1H",), 	  1200.0, 1600.0, 2500.0, 0.35], 
]

#########################################################################################################################################################

class Shank (Enm_Def.NPCPerson):

	HitImpulse = [0.0,0.0,0.0]
	last_hit_in_air= FALSE
	AGE_Number=0
	

	def __init__(self, me):
		# base class init
		Enm_Def.NPCPerson.__init__(self, me)
		self.HitImpulse = [0.0,0.0,0.0]

		me.ImDeadFunc=self.ImDeadFunc
		me.AddAnmEventFunc("Spit", self.StartSpit)
		me.InflictHitFunc = self.InflictHitFunc

		

		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = -1.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 20.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0


	# Functions for loading and saving state
	def __getstate__(self):	
		#self.changed_func[6] = 1
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			print "ERROR: Spidersmall.__getstate__(): Base class version differs."			
			return NPCPerson_state
		NPCPerson_state[1]["Shank"]=(self.AGE_Number,self.last_hit_in_air,self.HitImpulse)
		return NPCPerson_state		

	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["Shank"]
			self.AGE_Number=parms[0]
			self.last_hit_in_air=parms[1]
			self.HitImpulse=parms[2]
		
		me=Bladex.GetEntity(self.Name)
		me.AddAnmEventFunc("Spit", self.StartSpit)
		

	def ResetSounds(self, EntityName):
		#AniSound.AsignarSonidosAranita(EntityName)
		pass
		

	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.BlockingPropensity = 0.0
			me.AttackList = BCopy.deepcopy(ShankAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0
	
	def InflictHitFunc (self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		me = Bladex.GetEntity(EntityName)		
		# this should encourage the others to attack
		me.Data.CallGroupMemberFunc(EntityName, Combat.TempMoveInProc, 0)
		
	def ImDeadFunc (self,EntityName):
		Reference.debugprint(EntityName+": (Spider) I died!")
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		me = Bladex.GetEntity(EntityName)
		#pdb.set_trace()
		if self.last_hit_in_air:
			me.Wuea=Reference.WUEA_ENDED	
			me.InterruptCombat()	
			me.LaunchAnmType("dth2")

	# Overide the MutilateFunc because we don't want limbs we can pick up
	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		Blood.Mutilate (EntityName,obj_name,x,y,z,nx,ny,nz,node)

	def HitFunc (self, EntityName, WeaponName, Cx, Cy, Cz, Px, Py, Pz,wcx,wcy,wcz,wdx,wdy,wdz):
		Enm_Def.NPCPerson.HitFunc(self, EntityName, WeaponName, Cx, Cy, Cz, Px, Py, Pz,wcx,wcy,wcz,wdx,wdy,wdz)
		me = Bladex.GetEntity(EntityName)
		self.HitImpulse[0]= Px*0.20;
		self.HitImpulse[1]= Py*0.20;
		self.HitImpulse[2]= Pz*0.20;
		print EntityName+": Im hit"
		
		# discourage the others from attacking
		if me and me.Life>0:
			me.Data.CallGroupMemberFunc(EntityName, Combat.TempMoveOutProc, 0)

		self.last_hit_in_air= Py<0
		if self.last_hit_in_air:
			me.Angle= B3DLib.GetXZAngle(-self.HitImpulse[0], 0.0, -self.HitImpulse[2])
			me.SetActiveEnemy(None)
		

	def VenomPrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind=="Spidersmall":
					# Need to check immunity
					#ptcl=Bladex.GetEntity(prtl_name)
					#print (hit_entity+" was hit by "+prtl_name+ " of type "+ptcl.Kind)
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,   1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Venom", +2.0]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Poison", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]

					# Generate a smoke effect
					smoke=Bladex.CreateEntity("FuegoVerde", "Entity Particle System D1", x, y, z)
					smoke.ParticleType="VenomSmoke"
					smoke.YGravity=-100.0
					smoke.Friction=0.05
					smoke.PPS=8
					smoke.Velocity=0.0, -80.0, 0.0
					smoke.RandomVelocity=5.0
					smoke.DeathTime=Bladex.GetTime()+1.0
					node= 0
					victim.LinkToNode(smoke,node)
					
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has been converted to smoke
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()
			
		
	def SpitFunc(self, venom_name,end_time,period):
		venom=Bladex.GetEntity(venom_name)
		if(venom):
			prtl=venom.GetParticleEntity()
			prtl.HitFunc=self.VenomPrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.SpitFunc,(venom_name,end_time,period))	
				
	def StartSpit (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		self.AGE_Number=self.AGE_Number+1
		end_time=Bladex.GetTime()+0.5
		period= 0.125
		node= 0		
		x,y,z= me.GraspPos("ViewPoint")
		venom=Bladex.CreateEntity(EntityName+"_Venom_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
		venom.ParticleType="Venom"
		venom.YGravity=9800.0
		venom.Friction=0.075
		venom.PPS=512
		venom.DeathTime=end_time+1.0/60.0;
		vx,vy,vz=me.Rel2AbsVector(0,-14000.0,6500.0)
		venom.Velocity=vx,vy,vz
		venom.RandomVelocity=5.0
		me.LinkToNode(venom,node)

		self.SpitFunc(venom.Name, end_time, period)
	
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		me = Bladex.GetEntity(EntityName)
				
		if me and me.Life > 0:
			damage_factor = DamagePoints / (me.Life+DamagePoints)
			if damage_factor > self.DamageFactorNone:
				if DamageZone >= 0 and DamageZone < 32:
					me.SetWoundedZone(DamageZone, 1)

		# Consider getting furious
		if AttackerName and AttackerName != 'BWorld':
			me = Bladex.GetEntity(EntityName)
			if me and me.Life > 0:
				# consider getting furious
				if whrandom.random() < self.ChanceOfFuryOnHurt:
					self.GetFurious (EntityName)
		
		# launch appropriate hurt anim
		if me and me.Life > 0:
			me.Wuea=Reference.WUEA_ENDED	
			me.InterruptCombat()	
			damage_factor = DamagePoints / (me.Life+DamagePoints)
			if damage_factor > self.DamageFactorNone:
				if damage_factor < self.DamageFactorHeavy:	
					me.LaunchAnmType("hurt_lite")
				else:
					me.LaunchAnmType("hurt_big")




ShankAttackData = [
           # attacks:
            [Combat.ATTACK, 0.25, ("GA",),              500.0, 1000.0, 1400.0, 0.35],
            [Combat.ATTACK, 0.03, ("SP",),             2800.0, 3000.0, 3500.0, 0.20],

           # inner zone moves:
            [Combat.MOVE,   0.25, Combat.FearFire,               0.0, 1700.0, 2500.0, 0.05],
]

########################################################################################################################################################


class FriendlyMinotaur (Ally_Def.NPCAlly):
	def __init__(self, me):
		# base class init
		Ally_Def.NPCAlly.__init__(self, me)

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		self.DamageFactorNone  = 0.25
		self.DamageFactorLight = 0.33
		self.DamageFactorHeavy = 0.5
		
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosMinotaur(EntityName)

	def ResetCombat (self,EntityName):
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 2.0
			me.BlockingPropensity = 0.6
			me.AttackList = BCopy.deepcopy(FriendlyMinotaurAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0
			
			
FriendlyMinotaurAttackData =	[            
            [AllyCombat.ATTACK, 0.18, ("G01",),            1500.0, 3000.0, 3500.0, 0.35],
            [AllyCombat.ATTACK, 0.18, ("G07",),            1500.0, 3000.0, 3500.0, 0.35],
            [AllyCombat.ATTACK, 0.18, ("G08",),            1500.0, 3000.0, 3500.0, 0.35],
            [AllyCombat.ATTACK, 0.06, ("G12",),            2800.0, 3300.0, 3750.0, 0.35],
            [AllyCombat.ATTACK, 0.06, ("G31",),            2800.0, 3300.0, 3750.0, 0.35]
]

#########################################################################################################################################################


##########################################################################################################################################################
###### Improved Version

class RideableSalamander (Ally_Def.NPCAlly):
	
	AGE_Number=0
	rideron=0
	
	Deathfunc=None
	Deathargs=()
	
	def __init__(self, me):
		# base class init
		Ally_Def.NPCAlly.__init__(self, me)

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0

		# constants
		self.DamageFactorNone  = 0.15
		self.DamageFactorLight = 0.25

		me.AddAnmEventFunc("Spit", self.StartSpit)
		
		me.ImDeadFunc=self.NewImDeadFunc
		me.SendTriggerSectorMsgs=1

	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=Ally_Def.NPCAlly.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			print "ERROR: Salamander.__getstate__(): Base class version differs."
			return NPCPerson_state
		NPCPerson_state[1]["RideableSalamander"]=(self.AGE_Number,
						          self.rideron,
						          GameStateAux.SaveFunctionAux(self.Deathfunc),
						          self.Deathargs)
		return NPCPerson_state
	
	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Ally_Def.NPCAlly.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["RideableSalamander"]
			self.AGE_Number=parms[0]
			self.rideron=parms[1]
			GameStateAux.LoadFunctionAux(parms[2],self,"Deathfunc")
			self.Deathargs=parms[3]
			
		me=Bladex.GetEntity(self.Name)
		me.AddAnmEventFunc("Spit", self.StartSpit)


	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosSalamander(EntityName)


	def ResetCombat (self,EntityName):
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 2.0
			me.BlockingPropensity = 0.2
			me.AttackList = BCopy.deepcopy(RideableSalamanderAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0
			
			
	def NoRider (self,EntityName):
		self.rideron=0


	def FirePrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind=="Salamander":
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,   1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Fire", +6.0]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Fire", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]

					# Generate a smoke effect
					smoke=Bladex.CreateEntity("FireballSmoke", "Entity Particle System D1", x, y, z)
					smoke.ParticleType="DarkSmoke"
					smoke.YGravity=-3000.0
					smoke.Friction=0.05
					smoke.PPS=8
					smoke.Velocity=0.0, -80.0, 0.0
					smoke.RandomVelocity=5.0
					smoke.DeathTime=Bladex.GetTime()+0.5
					node= 0
					victim.LinkToNode(smoke,node)
					
					# Override hurt anim
					if victim.Life>0:
						Damage.DropInvalidObjectsOnImpact (victim.Name)
						victim.Wuea=Reference.WUEA_ENDED
						if victim.InCombat: 
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
						else: 
							victim.LaunchAnmType("hurt_f_big")
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has been converted to smoke
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()
			
		
	def SpitFunc(self, fireball_name,end_time,period):
		fireball=Bladex.GetEntity(fireball_name)
		if(fireball):
			prtl=fireball.GetParticleEntity()
			prtl.HitFunc=self.FirePrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.SpitFunc,(fireball_name,end_time,period,))
				
	def StartSpit (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		if me.InCombat: 
			SQDistance= me.SQDistance2(Bladex.GetEntity(me.GetEnemyName()))
			max_firefan_dist= 4000.0
			
			# Get an angle to the target
			target= Bladex.GetEntity(me.GetEnemyName())
			target_pos= target.Position
			x,y,z= me.GraspPos("ViewPoint")
			angle= -B3DLib.GetYAngle(target_pos[0]-x,target_pos[1]-y,target_pos[2]-z)
			
			if  SQDistance < (max_firefan_dist*max_firefan_dist):
				# fan out spit
				duration= 0.3
				self.AGE_Number=self.AGE_Number+1
				end_time=Bladex.GetTime()+duration
				period= duration/10.0
				fireball=Bladex.CreateEntity(EntityName+"_Firefanl_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
				fireball.ParticleType="Flame"
				fireball.Time2Live=20
				fireball.YGravity=-4900.0
				fireball.Friction=0.12
				fireball.PPS=512
				fireball.DeathTime=end_time;
				F= 5400.0             # Vector magnitude
				vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)
				fireball.Velocity=vx,vy,vz
				fireball.RandomVelocity=55.0
				self.SpitFunc(fireball.Name, end_time, period)
			else:
				# fireball spit
				nparticles= 70
				duration= 2.0/60.0 # I think this is a minimum
				self.AGE_Number=self.AGE_Number+1
				end_time=Bladex.GetTime()+duration
				period= duration/7.0
				fireball=Bladex.CreateEntity(EntityName+"_Fireball_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
				fireball.ParticleType="LargeFire"
				fireball.Time2Live=30
				fireball.YGravity=-400.0
				fireball.Friction=0.075
				fireball.PPS=nparticles/duration
				fireball.DeathTime=end_time;
				F= 25000.0             # Vector magnitude
				vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)
				fireball.Velocity=vx,vy,vz
				fireball.RandomVelocity=15.0
				self.SpitFunc(fireball.Name, end_time, period)
	
	
	
	
	def MountUp(self,EntityName,WeaponName="Garrote",RiderType="Great_Ork"):
		me=Bladex.GetEntity(EntityName)
		lvl=me.Level
		pos=me.Position
		ang=me.Angle
		me.Position=-37855.4091742,8819.60432338,-138227.588383
		me.Angle=0.128411348394
		
		
		
		rider=Bladex.CreateEntity(EntityName+"Rider",RiderType,-37935.4179389,8159.58628136,-138207.590697)
		rider.Person=1
		rider.Level=lvl
		rider.Data=OrkRider(rider)
		rider.Data.SetMountName(rider,EntityName)
		self.rideron=1
		wp=Bladex.CreateEntity(EntityName+"RiderWP",WeaponName,0,0,0,"Weapon")
		wp.Scale=1
		try:
			ItemTypes.ItemDefaultFuncs(wp)
		except:
			print"Rider weapon not classified in Item Types"
		Actions.TakeObject(rider.Name,wp.Name)
		me.LinkToNode(rider, me.GetNodeIndex("Center"))
		me.Position=pos[0],pos[1],pos[2]
		me.Angle=ang
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,me.UnFreeze,())
		
		backuprider=Bladex.CreateEntity(EntityName+"BackupRider",RiderType,0,0,0)
		backuprider.Person=1
		backuprider.Level=lvl
		backuprider.Data=OrkBackupRider(backuprider)
		if self.Deathfunc:
			backuprider.Data.Deathfunc=self.Deathfunc
		backuprider.Freeze()
		backuprider.RemoveFromWorld()
		self.rideron=1
		
		print"Sal rider mounted"
		
	
		
	
	def NewImDeadFunc (self,EntityName):
		me=Bladex.GetEntity(EntityName)
		if self.rideron==1:
			rider=Bladex.GetEntity(EntityName+"Rider")
			if rider.Life>0:
				pos=rider.Position
				ang=rider.Angle
				wp=Bladex.GetEntity(EntityName+"RiderWP")
				inv=rider.GetInventory()
				inv.LinkRightHand("None")
				inv.RemoveWeapon(wp.Name)
				me.Unlink(rider)
				rider.Freeze()
				rider.RemoveFromWorld()
				rider.Position=0,0,0
				remlife=rider.Life
				
				backuprider=Bladex.GetEntity(EntityName+"BackupRider")
				backuprider.Position=pos[0],pos[1],pos[2]
				backuprider.Angle=ang
				backuprider.Life=remlife
				backuprider.UnFreeze()
				backuprider.PutToWorld()
				Actions.TakeObject(backuprider.Name,wp.Name)
				backuprider.SetOnFloor()
				print EntityName+"_my horse has been killed"
				try:
					char = Bladex.GetEntity("Player1")
					if char.ActiveEnemy == rider.Name:
						char.SetActiveEnemy(backuprider.Name)
				except:
					pass
		
		Ally_Def.NPCAlly.StdImDead(self,EntityName)
		
		if self.Deathfunc:
			apply(self.Deathfunc,self.Deathargs)
		
		

				
RideableSalamanderAttackData =	[  
           # attacks:
            [Combat.ATTACK, 0.30, ("g_bite",),            3400.0, 3700.0, 4200.0, 0.35],
            [Combat.ATTACK, 0.10, ("g_r",),               2500.0, 2800.0, 3500.0, 0.35],            
            [Combat.ATTACK, 0.01, ("spit",),               0.0, 1500.0, 3950.0, 0.35],
            [Combat.ATTACK, 0.02, ("spit",),               0.0, 1500.0, 2274.0, 0.35],
            [Combat.ATTACK, 0.04, ("spit",),             6000.0,9000.0,10000.0, 0.35],
]
   
   
#########################################################################################################################################################
#### Active Rider if Salamander is killed

class OrkBackupRider (AllyOrk):

	Deathfunc=None
	Deathargs=()

	def __init__(self, me):
		# base class init
		AllyOrk.__init__(self, me)
		
		me.ImDeadFunc=self.NewImDeadFunc
		me.SendTriggerSectorMsgs=1
		
		
	# Functions for loading and saving state
	def __getstate__(self):
		# Tiene que devolver cmo poder guardar el estado de la clase
		NPCPerson_state=AllyOrk.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			print "ERROR: Ork.__getstate__(): Base class version differs."
			# Throw?
			return NPCPerson_state
		NPCPerson_state[1]["OrkBackupRider"]=(GameStateAux.SaveFunctionAux(self.Deathfunc),self.Deathargs)
		return NPCPerson_state
		

	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		AllyOrk.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["OrkBackupRider"]
			GameStateAux.LoadFunctionAux(parm[2],self,"Deathfunc")
			self.Deathargs=parm[3]
		


		
	def NewImDeadFunc (self,EntityName):
		Ally_Def.NPCAlly.StdImDead(self,EntityName)
		if self.Deathfunc:
			apply(self.Deathfunc,self.Deathargs)
		
		
		
#########################################################################################################################################################
## Dummy Rider

class OrkRider (Ally_Def.NPCAlly):

	mountname=None

	def __init__(self, me):
		# base class init
		Ally_Def.NPCAlly.__init__(self, me)
		# anims
		me.AnmTranFunc=AuxTran.AuxTranOrc
		
		
		InvestigatingSound = FALSE
		SoundPriorities = [-1.0, -1.0, -1.0, -1.0, -1.0]

		
		
		self.NPC = 1
		
		me.ImDeadFunc=self.NewImDeadFunc
		me.SeeFunc=self.InitSeeFunc
		me.HearFunc=self.InitHearFunc
		
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.Kind=="Ork":
			AniSound.AsignarSonidosOrco(EntityName)
		elif me.Kind=="Great_Ork":
			AniSound.AsignarSonidosOrcoGrande(EntityName)
	
	
		
		
	# Functions for loading and saving state
	def __getstate__(self):
		# Tiene que devolver cmo poder guardar el estado de la clase
		NPCPerson_state=Ally_Def.NPCAlly.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			print "ERROR: Ork.__getstate__(): Base class version differs."
			# Throw?
			return NPCPerson_state
		NPCPerson_state[1]["OrkRider"]=(self.mountname)
		return NPCPerson_state
		

	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Ally_Def.NPCAlly.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["OrkRider"]
			self.mountname=parms[0]
			
		me=Bladex.GetEntity(self.Name)
		me.AnmTranFunc=AuxTran.AuxTranOrc


		
	def NewImDeadFunc (self,EntityName):
		me=Bladex.GetEntity(EntityName)
		mount=Bladex.GetEntity(self.mountname)
		try:
			mount.Unlink(me)
		except:
			pass
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.1,self.FallOff,(EntityName,))
		
			
	def FallOff (self,EntityName):
		me=Bladex.GetEntity(EntityName)
		mount=Bladex.GetEntity(self.mountname)
		mount.Data.NoRider(mount)
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.2,self.HitTheDeck,(EntityName,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.2,self.HitTheDeck,(EntityName,)) # In case he gets stuck up in the air
		Ally_Def.NPCAlly.StdImDead(self,EntityName)
		print EntityName+"_falling off"
		
			
	def HitTheDeck(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		me.SetOnFloor()
		print EntityName+"on the ground"
	
	def InitSeeFunc(self,EntityName):
		pass
		
	def InitHearFunc(self,EntityName, SoundName, x, y, z, Volume):
		Reference.debugprint (EntityName + ": I hear something but I am not bothered.")
		pass
		
		
		
		
	def SetMountName(self,EntityName,MountName):
		self.mountname=MountName
		print "mount name set"
		print MountName
		
		
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		att=Bladex.GetEntity(AttackerName)
		if att.Kind=="Salamander":
			return
		Ally_Def.NPCAlly.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
		
		

		
		
			
