######################################################
#
# Create sets of attacks
#
#         Modified for Gold Orc
#
######################################################


import Bladex

ATK_UNIQUE=0
ATK_RANDOM=1
ATK_SEQUENTIAL=2

# Predeclare & link all my combos into ATTACKING action event tables
Bladex.SetActionEventTable("Grx","g_01","ATTACKING")
Bladex.SetActionEventTable("Grx","g_02","ATTACKING")
Bladex.SetActionEventTable("Grx","g_06","ATTACKING")
Bladex.SetActionEventTable("Grx","g_15","ATTACKING")
Bladex.SetActionEventTable("Grx","g_16","ATTACKING")
Bladex.SetActionEventTable("Grx","g_18","ATTACKING")

#Bladex.SetActionEventTable("Grx","g_17","ATTACKING")

Bladex.SetActionEventTable("Grx","g_01low_new","ATTACKING")    ####


Bladex.SetActionEventTable("Grx","g_spears1","ATTACKING")
Bladex.SetActionEventTable("Grx","g_spear08","ATTACKING")
Bladex.SetActionEventTable("Grx","g_spear12","ATTACKING")
Bladex.SetActionEventTable("Grx","g_spears6","ATTACKING")
Bladex.SetActionEventTable("Grx","g_spear16low","ATTACKING")

Bladex.SetActionEventTable("Grx","g_spear_2katab6low","ATTACKING")

Bladex.SetActionEventTable("Grx","g_spear19","ATTACKING")    ####




# Predeclare & link all my dodges into DODGING action event tables
Bladex.SetActionEventTable("Grx","D_r", "DODGING")
Bladex.SetActionEventTable("Grx","D_l", "DODGING")
Bladex.SetActionEventTable("Grx","D_b", "DODGING")


Bladex.SetActionEventTable("Grx","g_draw_rlx", "ATTACKING")
Bladex.SetActionEventTable("Grx","g_draw_run", "ATTACKING")


Bladex.SetActionEventTable("Grx","g_punch1","ATTACKING")
Bladex.SetActionEventTable("Grx","g_punch2","ATTACKING")
Bladex.SetActionEventTable("Grx","g_kick","ATTACKING")

Bladex.SetActionEventTable("Grx","g_back","ATTACKING")

Bladex.SetActionEventTable("Grx","g_bad_sword1","ATTACKING")
Bladex.SetActionEventTable("Grx","g_bad_sword2","ATTACKING")
Bladex.SetActionEventTable("Grx","g_bad_sword3","ATTACKING")
Bladex.SetActionEventTable("Grx","g_bad_spear2","ATTACKING")


Bladex.SetActionEventTable("Grx","g_bad_axe", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Grx","g_bad_spear", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Grx","g_bad_sword", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Grx","g_bad_no", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Grx","g_bad_1h", "ATTACKING_NOMOVE")


#############################################################



grx=Bladex.GetCharType("Gold_Orx","Grx")

#############################################################
##### NPC only
"""
grx.AttackTypeFlag("COMBO1",ATK_SEQUENTIAL)
grx.AddAttack("COMBO1","Grx_g_06")
grx.AddAttack("COMBO1","Grx_g_02")
grx.AddAttack("COMBO1","Grx_g_18")

grx.AttackTypeFlag("COMBO2",ATK_SEQUENTIAL)
grx.AddAttack("COMBO2","Grx_g_16")
grx.AddAttack("COMBO2","Grx_g_01")

grx.AttackTypeFlag("COMBO3",ATK_SEQUENTIAL)
grx.AddAttack("COMBO3","Grx_g_02")
grx.AddAttack("COMBO3","Grx_g_06")
grx.AddAttack("COMBO3","Grx_g_01")

###############################
# GRUPO PARA ESCALERAS        #
###############################
grx.AddAttack("STAIRS","Grx_g_16")
grx.AssignTrail("STAIRS","","EstelaAmarilla1")
grx.AddAttack("STAIRS","Grx_g_18")
grx.AssignTrail("STAIRS","","EstelaRoja1")
grx.AttackTypeFlag("STAIRS",ATK_RANDOM)
"""
##############################################################

#GI "group"
grx.AddAttack("G1_1H","Grx_g_01")
grx.AttackWindow("Grx_g_01",0.001,0.999,"G1_1H_Window")


#COMBO1 # left
grx.AddAttack("GM12_1H","Grx_g_02")
grx.AttackWindow("Grx_g_02",0.408,0.725,"GM12_1H_Window")
grx.AddLevels("Grx_g_02",0,40)


#COMBO2 # right
grx.AddAttack("GM14_1H","Grx_g_06")
grx.AttackWindow("Grx_g_06",0.265,0.586,"GM14_1H_Window")
grx.AddLevels("Grx_g_06",0,40)


#COMBO3 # windmill
grx.AddAttack("GM16_1H","Grx_g_16")
grx.AttackWindow("Grx_g_16",0.391,0.661,"GM16_1H_Window")
grx.AddLevels("Grx_g_16",0,40)


#COMBO4 # down
grx.AddAttack("GM18_1H","Grx_g_18")
grx.AttackWindow("Grx_g_18",0.001,0.900,"GM18_1H_Window")
grx.AddLevels("Grx_g_18",0,40)


### low
grx.AddAttack("GM19_1H","Grx_g_01low_new")#### dwf
grx.AttackWindow("Grx_g_01low_new",0.001,0.900,"GM19_1H_Window")
grx.AddLevels("Grx_g_01low_new",0,40)

######




#### unarmed

grx.AddAttack("GM22_NO","Grx_g_punch1")   # was 19
grx.AddLevels("Grx_g_punch1",0,40)

#GOLPESINARMA2 "group"
grx.AddAttack("GM20_NO","Grx_g_punch2")
grx.AddLevels("Grx_g_punch2",0,40)

#GOLPESINARMA3 "group"
grx.AddAttack("GM21_NO","Grx_g_kick")
grx.AddLevels("Grx_g_kick",0,40)

#### Bad moves

#COMBOHACHATORPE group
grx.AddAttack("GM1_AXE","Grx_g_bad_axe")
grx.AttackWindow("Grx_g_bad_axe",0.435,0.643,"GM1_AXE_Window")
grx.AssignTrail("GM1_AXE","","EstelaAmarilla1")
grx.AddLevels("Grx_g_bad_axe",0,8)

#COMBOHACHATORPE2 group
grx.AddAttack("GM7_AXE","Grx_g_bad_spear")
grx.AttackWindow("Grx_g_bad_spear",0.461,0.748,"GM7_AXE_Window")
grx.AssignTrail("GM7_AXE","","EstelaAmarilla1")
grx.AddLevels("Grx_g_bad_spear",0,20)

#COMBOESPADATORPE1 group
grx.AddAttack("GM2_2W","Grx_g_bad_sword1")
grx.AttackWindow("Dwf_g_bad_sword1",0.225,0.575,"GM2_2W_Window")
grx.AssignTrail("GM2_2W","","EstelaAmarilla1")
grx.AddLevels("Dwf_g_bad_sword1",0,40)

#COMBOESPADATORPE2 group
grx.AddAttack("GM3_2W","Grx_g_bad_sword2")
grx.AttackWindow("Grx_g_bad_sword2",0.464,0.741,"GM3_2W_Window")
grx.AssignTrail("GM3_2W","","EstelaAmarilla1")
grx.AddLevels("Grx_g_bad_sword2",0,40)

#COMBOESPADATORPE2 group
grx.AddAttack("GM4_2W","Grx_g_bad_sword3")
grx.AttackWindow("Grx_g_bad_sword3",0.427,0.807,"GM4_2W_Window")
grx.AssignTrail("GM4_2W","","EstelaAmarilla1")
grx.AddLevels("Grx_g_bad_sword3",0,40)

########################
#COMBOLANZATORPE1 group
#grx.AddAttack("GM5_SP","Grx_g_bad_spear")
#grx.AttackWindow("Grx_g_bad_spear",0.283,0.519,"GM5_SP_Window")
#grx.AssignTrail("GM5_SP","","EstelaAmarilla1")
#grx.AddLevels("Grx_g_bad_spear",0,40)

#COMBOLANZATORPE2 group
#grx.AddAttack("GM6_SP","Grx_g_bad_spear2")
#grx.AttackWindow("Grx_g_bad_spear2",0.461,0.748,"GM6_SP_Window")
#grx.AssignTrail("GM6_SP","","EstelaAmarilla1")
#grx.AddLevels("Grx_g_bad_spear2",0,40)

#######################


#GI "group"
grx.AddAttack("GI_SP","Grx_g_spears1")
grx.AttackWindow("Grx_g_spears1",0.334,0.642,"GI_SP_Window")
#grx.AttackTypeFlag("GI_SP",ATK_UNIQUE) #If only one attack given , UNIQUE flag is applied

#COMBO1 group
grx.AddAttack("GM1_SP","Grx_g_spear08")
grx.AttackWindow("Grx_g_spear08",0.121,0.496,"GM1_SP_Window")
grx.AddLevels("Grx_g_spear08",0,40)

#COMBO2 group
grx.AddAttack("GM3_SP","Amz_g_spear12")
grx.AttackWindow("Grx_g_spears12",0.183,0.448,"GM3_SP_Window")
grx.AddLevels("Grx_g_spears12",0,40)


#COMBO3 group
grx.AddAttack("GM6_SP","Grx_g_spears6")
grx.AttackWindow("Grx_g_spears6",0.345,0.454,"GM6_SP_Window")
grx.AddLevels("Grx_g_spears6",0,40)


#COMBO4 group
grx.AddAttack("GM8_SP","Grx_g_spear16low")
grx.AttackWindow("Grx_g_spear16low",0.341,0.475,"GM8_SP_Window")
grx.AddLevels("Grx_g_spear16low",0,40)

#
#COMBO BICHERO
grx.AddAttack("GM10_SP","Grx_g_spear_2katab6low")
grx.AttackWindow("Grx_g_spear_2katab6low",0.424,0.655,"GM10_SP_Window")
grx.AssignTrail("GM10_SP","","EstelaAmarilla1")
grx.AddLevels("Grx_g_spear_2katab6low",0,40)


# COMBO Lanza
grx.AddAttack("GM32_SP","Grx_g_spear19")
grx.AttackWindow("Grx_g_spear19",0.001,0.999,"GM32_SP_Window")
grx.AssignTrail("GM32_SP","","EstelaAmarilla1")
grx.AddLevels("Grx_g_spear19",0,40)


################################################################################


#GAI meta-group

grx.MetaAttack("GIM_1H","G1_1H")
grx.MetaAttack("GIM_1H","GM12_1H")
grx.MetaAttack("GIM_1H","GM14_1H")
grx.MetaAttack("GIM_1H","GM16_1H")
grx.MetaAttack("GIM_1H","GM18_1H")
grx.MetaAttack("GIM_1H","GM19_1H")
grx.MetaAttack("GIM_1H","GM32_SP")
grx.MetaAttack("GIM_NO","GM22_NO")
grx.MetaAttack("GIM_NO","GM20_NO")
grx.MetaAttack("GIM_NO","GM21_NO")
grx.MetaAttack("GIM_AXE","GM1_AXE")
grx.MetaAttack("GIM_2W","GM2_2W")
grx.MetaAttack("GIM_2W","GM3_2W")
grx.MetaAttack("GIM_2W","GM4_2W")

grx.MetaAttack("GIM_SP","GI_SP")
grx.MetaAttack("GIM_SP","GM1_SP")
grx.MetaAttack("GIM_SP","GM3_SP")
grx.MetaAttack("GIM_SP","GM6_SP")
grx.MetaAttack("GIM_SP","GM8_SP")
grx.MetaAttack("GIM_SP","GM10_SP")

#grx.MetaAttack("GIM_SP","GM7_AXE")


grx.MetaAttack("GOLPEINICIAL","GI_SP")

grx.MetaAttack("COMBO1","GM12_1H")
grx.MetaAttack("COMBO1","GM14_1H")
grx.MetaAttack("COMBO1","GM16_1H")
grx.MetaAttack("COMBO1","GM18_1H")
grx.MetaAttack("GIM_1H","GM19_1H")
grx.MetaAttack("COMBO1","GM22_NO")
grx.MetaAttack("COMBO1","GM20_NO")
grx.MetaAttack("COMBO1","GM21_NO")
grx.MetaAttack("COMBO1","GM1_AXE")
grx.MetaAttack("COMBO1","GM2_2W")
grx.MetaAttack("COMBO1","GM3_2W")
grx.MetaAttack("COMBO1","GM4_2W")
grx.MetaAttack("COMBO1","GM5_SP")
grx.MetaAttack("COMBO1","GM6_SP")
grx.MetaAttack("COMBO1","GM7_AXE")

grx.MetaAttack("COMBO1","GM1_SP")
grx.MetaAttack("COMBO1","GM3_SP")
grx.MetaAttack("COMBO1","GM6_SP")
grx.MetaAttack("COMBO1","GM8_SP")
grx.MetaAttack("COMBO1","GM10_SP")
grx.MetaAttack("COMBO1","GM32_SP")




######################################################
#
#        - Attacks themselves -
#
######################################################

# *Name of NEW attack (anm name itself , group name or metagroup)
# *Keys
#       R , L , F , B -> Control keys
#       A -> Attack 
#       D -> Defense(block)
#     
# -->Keys Modifiers
#       a+b . Simultaneous press
#       !c . Should not be pressed
#       &d . Should be already pressed
# *Previous Historial
#       "GA,GA,GM,GGF"
# *Previous NEGATIVE historial
#       +/- idem b4
#
#
######################################################


#COMBOARRIBA1
grx.AllowAttack("GM12_1H","A+R","","GM12_1H","","1H")
grx.AllowAttack("GM12_1H","&A+R","","GM12_1H","","1H")


#COMBODERECHA1
grx.AllowAttack("GM14_1H","A+L","","GM14_1H","","1H")
grx.AllowAttack("GM14_1H","&A+L","","GM14_1H","","1H")


#COMBOIZQUIERDA1
grx.AllowAttack("GM19_1H","A+B","","GM19_1H","","1H")
grx.AllowAttack("GM19_1H","&A+B","","GM19_1H","","1H")


#COMBOABAJO1
grx.AllowAttack("GM18_1H","A+F","","GM18_1H","","1H")
grx.AllowAttack("GM18_1H","&A+F","","GM18_1H","","1H")


#GOLPESINARMA1
grx.AllowAttack("GM22_NO","A","","COMBO1,COMBO1","","NO")

#GOLPESINARMA2
grx.AllowAttack("GM20_NO","A+B","","COMBO1","","NO")
grx.AllowAttack("GM20_NO","&A+B","","COMBO1","","NO")

#GOLPESINARMA3
grx.AllowAttack("GM21_NO","A+F","","COMBO1","","NO")
grx.AllowAttack("GM21_NO","&A+F","","COMBO1","","NO")


###COMBOHACHATORPE2
grx.AllowAttack("GM7_AXE","A+R","","","GM7_AXE_Window","AXE")
grx.AllowAttack("GM7_AXE","&A+R","","","GM7_AXE_Window","AXE")

#COMBOHACHATORPE1
grx.AllowAttack("GM1_AXE","A","","","GM1_AXE_Window","AXE")

#COMBOESPADATORPE3
grx.AllowAttack("GM4_2W","A","GM3_2W","","GM3_2W_Window","2W")

#COMBOESPADATORPE2
grx.AllowAttack("GM3_2W","A","","COMBO1,COMBO1,COMBO1","GM4_2W_Window","2W")

###############################################################
#COMBOLANZATORPE2
#grx.AllowAttack("GM6_SP","A","GM5_SP","","GM5_SP_Window","SP")

#COMBOLANZATORPE1
#grx.AllowAttack("GM5_SP","A","","COMBO1,COMBO1,COMBO1","GM6_SP_Window","SP")
##################################################################
# high
grx.AllowAttack("GM1_SP","A+F","","GM1_SP","","SP")
grx.AllowAttack("GM1_SP","&A+F","","GM1_SP","","SP")

#COMBO TECLA DERECHA1
grx.AllowAttack("GM3_SP","A+R","","GM3_SP","","SP")
grx.AllowAttack("GM3_SP","&A+R","","GM3_SP","","SP")

#COMBO TECLA IZQUIERDA1
grx.AllowAttack("GM6_SP","A+L","","GM6_SP","","SP")
grx.AllowAttack("GM6_SP","&A+L","","GM6_SP","","SP")

#COMBO TECLA ABAJO1 low
grx.AllowAttack("GM8_SP","A+B","","GM8_SP","GM10_SP_Window","SP")
grx.AllowAttack("GM8_SP","&A+B","","GM8_SP","GM10_SP_Window","SP")

grx.AllowAttack("GM16_1H","R+L","GIM_1H","","GI_1H_Window","1H")   ## 16 windmill

grx.AllowAttack("GM32_SP","B+R","GI_SP","","GI_SP_Window","SP")

grx.AllowAttack("GM10_SP","B","GM1_SP","","","SP")

# 
grx.AllowAttack("GI_SP","A","","GIM_SP","GI_SP_Window","SP")

#GI
grx.AllowAttack("G1_1H","A","","GIM_1H","GI_1H_Window","1H")




print"loaded new Gold Orc combos"














