
import Bladex
import math
import DefAnims
##########################
# Create New Biped Data  #
##########################


    ####################
    #                  #
    # Gold Ork         #
    #                  #
    ####################
    

  
    
    
import GoldOrkAnm_def
GoldOrkAnm_def.InitGoldOrk()    

    

grx=Bladex.GetCharType("Gold_Orx","Grx")
grx.IntName="Grx" 


grx.TurnSpeed=4.5
grx.Jcost=2700
grx.MaxFall=4000
grx.DieFall=14000
grx.MaxStair=505
grx.Fov=math.pi/1.2
grx.MaxGrab=3500.0
grx.MedGrab=2500.0
grx.Min2Grab=1500.0

grx.MinTake=-500.0		# Min height above floor barbarian will take
grx.MaxTake1=250.0	# Max height above floor for Take1 Anim
grx.MaxTake2=550.0	# Max height above floor for Take2 Anim
grx.MaxTake3=1300.0	# Max height above floor for Take3 Anim
grx.MaxTake4=1900.0	# Max height above floor for Take4 Anim
grx.MaxTake5=3000.0	# Max height above floor for Take5 Anim
grx.Reach=2000.0	# Max distance from ork centre to obj centre to take

grx.MovFrwdSpeedInStrafe=1000  #Forwards speed when in strafe(combat mode only)
grx.MovBkwdSpeedInStrafe=1200  # 1000 #Idem backwards

grx.MaxCombatDist=16000        # 8000
grx.DistStop=2000.0
grx.DistStop2=5000.0
grx.MaxSeeDist=50000           #30000

grx.AddRouteAnim="Tkn_wai_01"
grx.AddRouteAnim="Tkn_wai_02"


#grx.NaturalWeapons=1  # model does not have damage groups :(

grx.SetNCDSpheres(2)  #Numero de esferas en el modelo de colisiones
grx.SetCDSphere(0,170.0,350.0)  #(numero de la espera, altura mm, radio mm)
grx.SetCDSphere(1,-150.0,500.0)  #(numero de la espera, altura mm, radio mm)

###############################################################################
#

def GoldOrxWhenFirst():
	Bladex.CreateBipedData("Grx","Gold_Orx")

	######################################################
	# Comment the next section when changes are complete #
	######################################################
	#import os

	#try:
	#	os.remove("..\\..\\AnmPak\\Grx.dat")
	#except:
	#	pass
	######################################################
	exitsPak=Bladex.LoadAnmRaceData("../../AnmPak/Grx.dat")

	import NUGoldOrkAnimationSet
	NUGoldOrkAnimationSet.LoadGoldOrkAnimationSet("Grx")
	import NUGoldOrkBAct
	import LinkTables
	LinkTables.LinkMe("Grx")
	import NUGoldOrkCombos

	import NuAnmFact
	NuAnmFact.AnmFactGrx()

	if not exitsPak:
		Bladex.SaveAnmRaceData("../../AnmPak/Grx.dat","Grx")
	
	print"New Gold Orx Data Set"
	

	
	Bladex.AddFloorCTolerance("slip",10)

	import BBLib
	try:
		BBLib.LoadResourceToMemory(BBLib.B_CID_BMP, "GoldOrcIcon")	
	except:
		pass
		
		
race=Bladex.GetCharType("Gold_Orx","Grx")
race.OnFirst=GoldOrxWhenFirst
