######################################################
#
# Create sets of attacks
#
#         Modified for Chief Orc
#
######################################################


import Bladex

ATK_UNIQUE=0
ATK_RANDOM=1
ATK_SEQUENTIAL=2

# Predeclare & link all my combos into ATTACKING action event tables
Bladex.SetActionEventTable("Crk","g_01","ATTACKING")
Bladex.SetActionEventTable("Crk","g_02","ATTACKING")
Bladex.SetActionEventTable("Crk","g_06","ATTACKING")
Bladex.SetActionEventTable("Crk","g_15","ATTACKING")
Bladex.SetActionEventTable("Crk","g_16","ATTACKING")
Bladex.SetActionEventTable("Crk","g_18","ATTACKING")



Bladex.SetActionEventTable("Crk","g_01low_new","ATTACKING")    ####

# Predeclare & link all my dodges into DODGING action event tables
Bladex.SetActionEventTable("Crk","D_r", "DODGING")
Bladex.SetActionEventTable("Crk","D_l", "DODGING")
Bladex.SetActionEventTable("Crk","D_b", "DODGING")


Bladex.SetActionEventTable("Crk","g_draw_rlx", "ATTACKING")
Bladex.SetActionEventTable("Crk","g_draw_run", "ATTACKING")


Bladex.SetActionEventTable("Crk","g_punch1","ATTACKING")
Bladex.SetActionEventTable("Crk","g_punch2","ATTACKING")
Bladex.SetActionEventTable("Crk","g_kick","ATTACKING")

Bladex.SetActionEventTable("Crk","g_back","ATTACKING")

Bladex.SetActionEventTable("Crk","g_bad_sword1","ATTACKING")
Bladex.SetActionEventTable("Crk","g_bad_sword2","ATTACKING")
Bladex.SetActionEventTable("Crk","g_bad_sword3","ATTACKING")
Bladex.SetActionEventTable("Crk","g_bad_spear2","ATTACKING")


Bladex.SetActionEventTable("Crk","g_bad_axe", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Crk","g_bad_spear", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Crk","g_bad_sword", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Crk","g_bad_no", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Crk","g_bad_1h", "ATTACKING_NOMOVE")



Bladex.SetActionEventTable("Crk","g2h_08","ATTACKING")
Bladex.SetActionEventTable("Crk","g2h_b6kata","ATTACKING")
Bladex.SetActionEventTable("Crk","g2h_12low","ATTACKING")
Bladex.SetActionEventTable("Crk","g2h_s7","ATTACKING")
Bladex.SetActionEventTable("Crk","g2h_11","ATTACKING")

Bladex.SetActionEventTable("Crk","g2h_21_6kata","ATTACKING")



Bladex.SetActionEventTable("Crk","g_axe01","ATTACKING")
Bladex.SetActionEventTable("Crk","g_axe08","ATTACKING")
Bladex.SetActionEventTable("Crk","g_axe18","ATTACKING")
Bladex.SetActionEventTable("Crk","g_axe111","ATTACKING")
Bladex.SetActionEventTable("Crk","g_axe13","ATTACKING")
Bladex.SetActionEventTable("Crk","g_axe02","ATTACKING")
Bladex.SetActionEventTable("Crk","g_axe31","ATTACKING")

#############################################################



crk=Bladex.GetCharType("Chief_Ork","Crk")

#############################################################
### NPC only
"""
crk.AttackTypeFlag("COMBO1",ATK_SEQUENTIAL)
crk.AddAttack("COMBO1","Crk_g_06")
crk.AddAttack("COMBO1","Crk_g_02")
crk.AddAttack("COMBO1","Crk_g_18")

crk.AttackTypeFlag("COMBO2",ATK_SEQUENTIAL)
crk.AddAttack("COMBO2","Crk_g_16")
crk.AddAttack("COMBO2","Crk_g_01")

crk.AttackTypeFlag("COMBO3",ATK_SEQUENTIAL)
crk.AddAttack("COMBO3","Crk_g_02")
crk.AddAttack("COMBO3","Crk_g_06")
crk.AddAttack("COMBO3","Crk_g_01")

###############################
# GRUPO PARA ESCALERAS        #
###############################
crk.AddAttack("STAIRS","Crk_g_16")
crk.AssignTrail("STAIRS","","EstelaAmarilla1")
crk.AddAttack("STAIRS","Crk_g_18")
crk.AssignTrail("STAIRS","","EstelaRoja1")
crk.AttackTypeFlag("STAIRS",ATK_RANDOM)
"""
##############################################################

#GI "group"
crk.AddAttack("G1_1H","Crk_g_01")
crk.AttackWindow("Crk_g_01",0.001,0.999,"G1_1H_Window")
#crk.AttackTypeFlag("g_01",ATK_UNIQUE)

#COMBO1 # left
crk.AddAttack("GM12_1H","Crk_g_02")
crk.AttackWindow("Crk_g_02",0.408,0.725,"GM12_1H_Window")
crk.AddLevels("Crk_g_02",0,40)


#COMBO2 # right
crk.AddAttack("GM14_1H","Crk_g_06")
crk.AttackWindow("Crk_g_06",0.265,0.586,"GM14_1H_Window")
crk.AddLevels("Crk_g_06",0,40)


#COMBO3 # windmill
crk.AddAttack("GM16_1H","Crk_g_16")
crk.AttackWindow("Crk_g_16",0.391,0.661,"GM16_1H_Window")
crk.AddLevels("Crk_g_16",0,40)


#COMBO4 # down
crk.AddAttack("GM18_1H","Crk_g_18")
crk.AttackWindow("Crk_g_18",0.001,0.900,"GM18_1H_Window")
crk.AddLevels("Crk_g_18",0,40)


### low
crk.AddAttack("GM19_1H","Crk_g_01low_new")#### dwf?
crk.AttackWindow("Crk_g_01low_new",0.001,0.900,"GM19_1H_Window")
crk.AddLevels("Crk_g_01low_new",0,40)


#### unarmed

crk.AddAttack("GM22_NO","Crk_g_punch1")   # was 19
crk.AddLevels("Crk_g_punch1",0,40)

#GOLPESINARMA2 "group"
crk.AddAttack("GM20_NO","Crk_g_punch2")
crk.AddLevels("Crk_g_punch2",0,40)

#GOLPESINARMA3 "group"
crk.AddAttack("GM21_NO","Crk_g_kick")
crk.AddLevels("Crk_g_kick",0,40)

#### Bad moves

#COMBOLANZATORPE1 group
crk.AddAttack("GM5_SP","Crk_g_bad_spear")
crk.AttackWindow("Crk_g_bad_spear",0.283,0.519,"GM5_SP_Window")
crk.AssignTrail("GM5_SP","","EstelaAmarilla1")
crk.AddLevels("Crk_g_bad_spear",0,40)

#COMBOLANZATORPE2 group
crk.AddAttack("GM6_SP","Crk_g_bad_spear2")
crk.AttackWindow("Crk_g_bad_spear2",0.461,0.748,"GM6_SP_Window")
crk.AssignTrail("GM6_SP","","EstelaAmarilla1")
crk.AddLevels("Crk_g_bad_spear2",0,40)

####### 2H sword

crk.AddAttack("GI_2H","Crk_g2h_08")
crk.AttackWindow("Crk_g2h_08",0.400,0.535,"GI_2H_Window")
crk.AddLevels("Crk_g2h_08",0,40)


#COMBO1 "group"
crk.AddAttack("GM1_2H","Crk_g2h_b6kata")
crk.AttackWindow("Crk_g2h_b6kata",0.443,0.569,"GM1_2H_Window")
crk.AddLevels("Crk_g2h_b6kata",0,40)

#COMBO2 "group"
crk.AddAttack("GM7_2H","Crk_g2h_s7")
crk.AttackWindow("Crk_g2h_s7",0.402,0.662,"GM7_2H_Window")
crk.AddLevels("Crk_g2h_s7",0,40)

#COMBO3 "group"
crk.AddAttack("GM4_2H","Crk_g2h_11")
crk.AttackWindow("Crk_g2h_11",0.272,0.502,"GM4_2H_Window")
crk.AddLevels("Crk_g2h_11",0,40)


#COMBO4 "group"
crk.AddAttack("GM10_2H","Crk_g2h_12low")
crk.AttackWindow("Crk_g2h_12low",0.312,0.595,"GM10_2H_Window")
crk.AddLevels("Crk_g2h_12low",0,40)


#COMBORAPIDOEXTRA1 "group"
crk.AddAttack("GM23_2H","Crk_g2h_21_6kata")
crk.AttackWindow("Crk_g2h_21_6kata",0.328,0.731,"GM23_2H_Window")
crk.AssignTrail("GM23_2H","","EstelaAmarilla1")
crk.AddLevels("Crk_g2h_21_6kata",8,40)

##### AXE

#GOLPEINICIOHACHA "group"
crk.AddAttack("GI_AXE","Crk_g_axe08")
crk.AttackWindow("Crk_g_axe08",0.218,0.435,"GI_AXE_Window")
crk.AddLevels("Crk_g_axe08",0,40)


#COMBOHACHA1 "group"
crk.AddAttack("GM17_AXE","Crk_g_axe18")
crk.AttackWindow("Crk_g_axe18",0.350,0.537,"GM17_AXE_Window")
crk.AddLevels("Crk_g_axe18",0,40)


#COMBOHACHA2 "group"
crk.AddAttack("GM19_AXE","Crk_g_axe02")
crk.AttackWindow("Crk_g_axe02",0.183,0.483,"GM19_AXE_Window")
crk.AddLevels("Crk_g_axe02",0,40)


#COMBOHACHA3 "group"
crk.AddAttack("GM21_AXE","Crk_g_axe13")
crk.AttackWindow("Crk_g_axe13",0.348,0.600,"GM21_AXE_Window")
crk.AddLevels("Crk_g_axe13",0,40)


#COMBOHACHA4 "group"
crk.AddAttack("GM28_AXE","Crk_g_axe111")
crk.AttackWindow("Crk_g_axe111",0.299,0.604,"GM28_AXE_Window")
crk.AddLevels("Crk_g_axe111",0,40)



#COMBOHACHA1 "group"
crk.AddAttack("GM18_AXE","Crk_g_axe01")
crk.AttackWindow("Crk_g_axe01",0.194,0.439,"GM18_AXE_Window")
crk.AssignTrail("GM18_AXE","","EstelaAmarilla1")
crk.AddLevels("Crk_g_axe01",7,40)



#COMBOALEATORIOEXTRA "group"
crk.AddAttack("GM31_AXE","Crk_g_axe31")
crk.AttackWindow("Crk_g_axe31",0.690,0.884,"GM31_AXE_Window")
crk.AssignTrail("GM31_AXE","","EstelaAmarilla1")
crk.AddLevels("Crk_g_axe31",10,40)



################################################################################


#GAI meta-group

crk.MetaAttack("GIM_1H","G1_1H")
crk.MetaAttack("GIM_AXE","G1_AXE")
crk.MetaAttack("GIM_1H","GM12_1H")
crk.MetaAttack("GIM_1H","GM14_1H")
crk.MetaAttack("GIM_1H","GM16_1H")
crk.MetaAttack("GIM_1H","GM18_1H")
crk.MetaAttack("GIM_1H","GM19_1H")
crk.MetaAttack("GIM_NO","GM22_NO")
crk.MetaAttack("GIM_NO","GM20_NO")
crk.MetaAttack("GIM_NO","GM21_NO")

crk.MetaAttack("GIM_SP","GM5_SP")
crk.MetaAttack("GIM_SP","GM6_SP")


crk.MetaAttack("GIM_2H","GI_2H")
crk.MetaAttack("GIM_2H","GM1_2H")
crk.MetaAttack("GIM_2H","GM4_2H")
crk.MetaAttack("GIM_2H","GM7_2H")
crk.MetaAttack("GIM_2H","GM10_2H")
crk.MetaAttack("GIM_2H","GM23_2H")


crk.MetaAttack("GIM_AXE","GM17_AXE")
crk.MetaAttack("GIM_AXE","GM19_AXE")
crk.MetaAttack("GIM_AXE","GM21_AXE")
crk.MetaAttack("GIM_AXE","GM28_AXE")
crk.MetaAttack("GIM_AXE","GM18_AXE")
crk.MetaAttack("GIM_AXE","GM31_AXE")

crk.MetaAttack("GOLPEINICIAL","GI_2H")

crk.MetaAttack("GOLPEINICIALHACHA","GI_AXE")

crk.MetaAttack("COMBO1","GM12_1H")
crk.MetaAttack("COMBO1","GM14_1H")
crk.MetaAttack("COMBO1","GM16_1H")
crk.MetaAttack("COMBO1","GM18_1H")

crk.MetaAttack("COMBO1","GM22_NO")
crk.MetaAttack("COMBO1","GM20_NO")
crk.MetaAttack("COMBO1","GM21_NO")

crk.MetaAttack("COMBO1","GM5_SP")
crk.MetaAttack("COMBO1","GM6_SP")

crk.MetaAttack("COMBO1","GM1_2H")
crk.MetaAttack("COMBO1","GM4_2H")
crk.MetaAttack("COMBO1","GM7_2H")
crk.MetaAttack("COMBO1","GM10_2H")
crk.MetaAttack("COMBO1","GM23_2H")

#crk.MetaAttack("COMBO1","GM1_AXE")#####
crk.MetaAttack("COMBO1","GM17_AXE")
crk.MetaAttack("COMBO1","GM19_AXE")
crk.MetaAttack("COMBO1","GM21_AXE")
crk.MetaAttack("COMBO1","GM28_AXE")
crk.MetaAttack("COMBO1","GM18_AXE")
crk.MetaAttack("COMBO1","GM31_AXE")


######################################################
#
#        - Attacks themselves -
#
######################################################

# *Name of NEW attack (anm name itself , group name or metagroup)
# *Keys
#       R , L , F , B -> Control keys
#       A -> Attack 
#       D -> Defense(block)
#     
# -->Keys Modifiers
#       a+b . Simultaneous press
#       !c . Should not be pressed
#       &d . Should be already pressed
# *Previous Historial
#       "GA,GA,GM,GGF"
# *Previous NEGATIVE historial
#       +/- idem b4
#
#
######################################################


#COMBOARRIBA1
crk.AllowAttack("GM12_1H","A+R","","GM12_1H","","1H")
crk.AllowAttack("GM12_1H","&A+R","","GM12_1H","","1H")


#COMBODERECHA1
crk.AllowAttack("GM14_1H","A+L","","GM14_1H","","1H")
crk.AllowAttack("GM14_1H","&A+L","","GM14_1H","","1H")


#COMBOIZQUIERDA1
crk.AllowAttack("GM19_1H","A+B","","GM19_1H","","1H")
crk.AllowAttack("GM19_1H","&A+B","","GM19_1H","","1H")


#COMBOABAJO1
crk.AllowAttack("GM18_1H","A+F","","GM18_1H","","1H")
crk.AllowAttack("GM18_1H","&A+F","","GM18_1H","","1H")


crk.AllowAttack("GM16_1H","R+L","GIM_1H","","GI_1H_Window","1H")   ## 16 windmill

#GI
crk.AllowAttack("G1_1H","A","","GIM_1H","GI_1H_Window","1H")

##########################################################
#GOLPESINARMA1
crk.AllowAttack("GM22_NO","A","","COMBO1,COMBO1","","NO")

#GOLPESINARMA2
crk.AllowAttack("GM20_NO","A+B","","COMBO1","","NO")
crk.AllowAttack("GM20_NO","&A+B","","COMBO1","","NO")

#GOLPESINARMA3
crk.AllowAttack("GM21_NO","A+F","","COMBO1","","NO")
crk.AllowAttack("GM21_NO","&A+F","","COMBO1","","NO")
############################################################

###COMBOHACHATORPE2
#crk.AllowAttack("GM7_AXE","A+R","","","GM7_AXE_Window","AXE")
#crk.AllowAttack("GM7_AXE","&A+R","","","GM7_AXE_Window","AXE")

#COMBOHACHATORPE1
#crk.AllowAttack("GM1_AXE","A","","","GM1_AXE_Window","AXE")

#COMBOESPADATORPE3
crk.AllowAttack("GM4_2W","A","GM3_2W","","GM3_2W_Window","2W")

#COMBOESPADATORPE2
#crk.AllowAttack("GM3_2W","A","","COMBO1,COMBO1,COMBO1","GM4_2W_Window","2W")

#COMBOLANZATORPE2
crk.AllowAttack("GM6_SP","A","GM5_SP","","GM5_SP_Window","SP")

#COMBOLANZATORPE1
crk.AllowAttack("GM5_SP","A","","COMBO1,COMBO1,COMBO1","GM6_SP_Window","SP")


crk.AllowAttack("GM16_1H","R+L","GIM_1H","","GI_1H_Window","1H")   ## 16 windmill

#####

crk.AllowAttack("GM1_2H","A+F","","GM1_2H","GM2_2H_Window","2W")
crk.AllowAttack("GM1_2H","&A+F","","GM1_2H","GM2_2H_Window","2W")

crk.AllowAttack("GM4_2H","A+R","","GM4_2H","GM5_2H_Window","2W")
crk.AllowAttack("GM4_2H","&A+R","","GM4_2H","GM5_2H_Window","2W")

crk.AllowAttack("GM7_2H","A+L","","GM7_2H","GM8_2H_Window","2W")
crk.AllowAttack("GM7_2H","&A+L","","GM7_2H","GM8_2H_Window","2W")

crk.AllowAttack("GM10_2H","A+B","","GM10_2H","GM11_2H_Window","2W")
crk.AllowAttack("GM10_2H","&A+B","","GM10_2H","GM11_2H_Window","2W")

crk.AllowAttack("GI_2H","A","","GIM_2H","GI_2H_Window","2W")

crk.AllowAttack("GM23_2H","F","GI_2H","GM23_2H","","2W")

##

#COMBOHACHA TECLA ABAJO1
crk.AllowAttack("GM28_AXE","A+B","","GM28_AXE","","AXE")
crk.AllowAttack("GM28_AXE","&A+B","","GM28_AXE","","AXE")

#COMBOHACHA TECLA IZQUIERDA1
crk.AllowAttack("GM21_AXE","A+L","","GM21_AXE","","AXE")
crk.AllowAttack("GM21_AXE","&A+L","","GM21_AXE","","AXE")

#COMBOHACHA TECLA ARRIBA1
crk.AllowAttack("GM17_AXE","A+F","","GM17_AXE","GM18_AXE_Window","AXE")
crk.AllowAttack("GM17_AXE","&A+F","","GM17_AXE","GM18_AXE_Window","AXE")


#COMBOHACHA TECLA ARRIBA2
crk.AllowAttack("GM18_AXE","A+F","GM17_AXE","","GM17_AXE_Window","AXE")
crk.AllowAttack("GM18_AXE","&A+F","GM17_AXE","","GM17_AXE_Window","AXE")



#COMBOHACHA TECLA DERECHA1
crk.AllowAttack("GM19_AXE","A+R","","GM19_AXE","","AXE")
crk.AllowAttack("GM19_AXE","&A+R","","GM19_AXE","","AXE")


#COMBOALEATORIOEXTRA1
crk.AllowAttack("GM31_AXE","L+R","GM17_AXE","","GM17_AXE_Window","AXE")


#GI
crk.AllowAttack("GI_AXE","A","","GI_AXE","GI_AXE_Window","AXE")

print"loaded new Orc combos"














