######################################################
#
# Create sets of attacks
#
#        - DWF - Modified for Orc
#
######################################################


import Bladex

ATK_UNIQUE=0
ATK_RANDOM=1
ATK_SEQUENTIAL=2

# Predeclare & link all my combos into ATTACKING action event tables
Bladex.SetActionEventTable("Orx","g_01","ATTACKING")
Bladex.SetActionEventTable("Orx","g_02","ATTACKING")
Bladex.SetActionEventTable("Orx","g_06","ATTACKING")
Bladex.SetActionEventTable("Orx","g_15","ATTACKING")
Bladex.SetActionEventTable("Orx","g_16","ATTACKING")
Bladex.SetActionEventTable("Orx","g_18","ATTACKING")

#Bladex.SetActionEventTable("Orx","g_17","ATTACKING")

Bladex.SetActionEventTable("Orx","g_01low_new","ATTACKING")    ####

Bladex.SetActionEventTable("Orx","g_spit","ATTACKING")



# Predeclare & link all my dodges into DODGING action event tables
Bladex.SetActionEventTable("Orx","D_r", "DODGING")
Bladex.SetActionEventTable("Orx","D_l", "DODGING")
Bladex.SetActionEventTable("Orx","D_b", "DODGING")


Bladex.SetActionEventTable("Orx","g_draw_rlx", "ATTACKING")
Bladex.SetActionEventTable("Orx","g_draw_run", "ATTACKING")


Bladex.SetActionEventTable("Orx","g_punch1","ATTACKING")
Bladex.SetActionEventTable("Orx","g_punch2","ATTACKING")
Bladex.SetActionEventTable("Orx","g_kick","ATTACKING")

Bladex.SetActionEventTable("Orx","g_back","ATTACKING")

Bladex.SetActionEventTable("Orx","g_bad_sword1","ATTACKING")
Bladex.SetActionEventTable("Orx","g_bad_sword2","ATTACKING")
Bladex.SetActionEventTable("Orx","g_bad_sword3","ATTACKING")
Bladex.SetActionEventTable("Orx","g_bad_spear2","ATTACKING")


Bladex.SetActionEventTable("Orx","g_bad_axe", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Orx","g_bad_spear", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Orx","g_bad_sword", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Orx","g_bad_no", "ATTACKING_NOMOVE")
Bladex.SetActionEventTable("Orx","g_bad_1h", "ATTACKING_NOMOVE")

#############################################################



orx=Bladex.GetCharType("Orx","Orx")

#############################################################
### NPC only
"""
orx.AttackTypeFlag("COMBO1",ATK_SEQUENTIAL)
orx.AddAttack("COMBO1","Orx_g_06")
orx.AddAttack("COMBO1","Orx_g_02")
orx.AddAttack("COMBO1","Orx_g_18")

orx.AttackTypeFlag("COMBO2",ATK_SEQUENTIAL)
orx.AddAttack("COMBO2","Orx_g_16")
orx.AddAttack("COMBO2","Orx_g_01")

orx.AttackTypeFlag("COMBO3",ATK_SEQUENTIAL)
orx.AddAttack("COMBO3","Orx_g_02")
orx.AddAttack("COMBO3","Orx_g_06")
orx.AddAttack("COMBO3","Orx_g_01")

###############################
# GRUPO PARA ESCALERAS        #
###############################
orx.AddAttack("STAIRS","Orx_g_16")
orx.AssignTrail("STAIRS","","EstelaAmarilla1")
orx.AddAttack("STAIRS","Orx_g_18")
orx.AssignTrail("STAIRS","","EstelaRoja1")
orx.AttackTypeFlag("STAIRS",ATK_RANDOM)
"""
##############################################################


orx.AddAttack("SP1","Orx_g_spit")
orx.AttackWindow("Orx_g_spit",0.001,0.999,"G1_1H_Window")
orx.AddLevels("Orx_g_spit",0,0)


#GI "group"
orx.AddAttack("G1_1H","Orx_g_01")
orx.AttackWindow("Orx_g_01",0.001,0.999,"G1_1H_Window")


#COMBO1 # left
orx.AddAttack("GM12_1H","Orx_g_02")
orx.AttackWindow("Orx_g_02",0.408,0.725,"GM12_1H_Window")
orx.AddLevels("Orx_g_02",0,40)


#COMBO2 # right
orx.AddAttack("GM14_1H","Orx_g_06")
orx.AttackWindow("Orx_g_06",0.265,0.586,"GM14_1H_Window")
orx.AddLevels("Orx_g_06",0,40)


#COMBO3 # windmill
orx.AddAttack("GM16_1H","Orx_g_16")
orx.AttackWindow("Orx_g_16",0.391,0.661,"GM16_1H_Window")
orx.AddLevels("Orx_g_16",0,40)


#COMBO4 # down
orx.AddAttack("GM18_1H","Orx_g_18")
orx.AttackWindow("Orx_g_18",0.001,0.900,"GM18_1H_Window")
orx.AddLevels("Orx_g_18",0,40)


### low
orx.AddAttack("GM19_1H","Orx_g_01low_new")#### dwf?
orx.AttackWindow("Orx_g_01low_new",0.001,0.900,"GM19_1H_Window")
orx.AddLevels("Orx_g_01low_new",0,40)


#### unarmed

orx.AddAttack("GM22_NO","Orx_g_punch1")   # was 19
orx.AddLevels("Orx_g_punch1",0,40)

#GOLPESINARMA2 "group"
orx.AddAttack("GM20_NO","Orx_g_punch2")
orx.AddLevels("Orx_g_punch2",0,40)

#GOLPESINARMA3 "group"
orx.AddAttack("GM21_NO","Orx_g_kick")
orx.AddLevels("Orx_g_kick",0,40)

#### Bad moves

#COMBOHACHATORPE group
orx.AddAttack("GM1_AXE","Orx_g_bad_axe")
orx.AttackWindow("Orx_g_bad_axe",0.435,0.643,"GM1_AXE_Window")
orx.AssignTrail("GM1_AXE","","EstelaAmarilla1")
orx.AddLevels("Orx_g_bad_axe",0,8)

#COMBOHACHATORPE2 group
orx.AddAttack("GM7_AXE","Orx_g_bad_spear")
orx.AttackWindow("Orx_g_bad_spear",0.461,0.748,"GM7_AXE_Window")
orx.AssignTrail("GM7_AXE","","EstelaAmarilla1")
orx.AddLevels("Orx_g_bad_spear",0,20)

#COMBOESPADATORPE1 group
orx.AddAttack("GM2_2W","Orx_g_bad_sword1")
orx.AttackWindow("Dwf_g_bad_sword1",0.225,0.575,"GM2_2W_Window")
orx.AssignTrail("GM2_2W","","EstelaAmarilla1")
orx.AddLevels("Dwf_g_bad_sword1",0,40)

#COMBOESPADATORPE2 group
orx.AddAttack("GM3_2W","Orx_g_bad_sword2")
orx.AttackWindow("Orx_g_bad_sword2",0.464,0.741,"GM3_2W_Window")
orx.AssignTrail("GM3_2W","","EstelaAmarilla1")
orx.AddLevels("Orx_g_bad_sword2",0,40)

#COMBOESPADATORPE2 group
orx.AddAttack("GM4_2W","Orx_g_bad_sword3")
orx.AttackWindow("Orx_g_bad_sword3",0.427,0.807,"GM4_2W_Window")
orx.AssignTrail("GM4_2W","","EstelaAmarilla1")
orx.AddLevels("Orx_g_bad_sword3",0,40)

#COMBOLANZATORPE1 group
orx.AddAttack("GM5_SP","Orx_g_bad_spear")
orx.AttackWindow("Orx_g_bad_spear",0.283,0.519,"GM5_SP_Window")
orx.AssignTrail("GM5_SP","","EstelaAmarilla1")
orx.AddLevels("Orx_g_bad_spear",0,40)

#COMBOLANZATORPE2 group
orx.AddAttack("GM6_SP","Orx_g_bad_spear2")
orx.AttackWindow("Orx_g_bad_spear2",0.461,0.748,"GM6_SP_Window")
orx.AssignTrail("GM6_SP","","EstelaAmarilla1")
orx.AddLevels("Orx_g_bad_spear2",0,40)



################################################################################


#GAI meta-group
orx.MetaAttack("GIM_1H","SP1")

orx.MetaAttack("GIM_1H","G1_1H")
orx.MetaAttack("GIM_1H","GM12_1H")
orx.MetaAttack("GIM_1H","GM14_1H")
orx.MetaAttack("GIM_1H","GM16_1H")
orx.MetaAttack("GIM_1H","GM18_1H")
orx.MetaAttack("GIM_1H","GM19_1H")
orx.MetaAttack("GIM_NO","GM22_NO")
orx.MetaAttack("GIM_NO","GM20_NO")
orx.MetaAttack("GIM_NO","GM21_NO")
orx.MetaAttack("GIM_AXE","GM1_AXE")
orx.MetaAttack("GIM_2W","GM2_2W")
orx.MetaAttack("GIM_2W","GM3_2W")
orx.MetaAttack("GIM_2W","GM4_2W")
orx.MetaAttack("GIM_SP","GM5_SP")
orx.MetaAttack("GIM_SP","GM6_SP")
orx.MetaAttack("GIM_SP","GM7_AXE")


orx.MetaAttack("COMBO1","SP1")

orx.MetaAttack("COMBO1","GM12_1H")
orx.MetaAttack("COMBO1","GM14_1H")
orx.MetaAttack("COMBO1","GM16_1H")
orx.MetaAttack("COMBO1","GM18_1H")
orx.MetaAttack("COMBO1","GM19_1H")
orx.MetaAttack("COMBO1","GM22_NO")
orx.MetaAttack("COMBO1","GM20_NO")
orx.MetaAttack("COMBO1","GM21_NO")
orx.MetaAttack("COMBO1","GM1_AXE")
orx.MetaAttack("COMBO1","GM2_2W")
orx.MetaAttack("COMBO1","GM3_2W")
orx.MetaAttack("COMBO1","GM4_2W")
orx.MetaAttack("COMBO1","GM5_SP")
orx.MetaAttack("COMBO1","GM6_SP")
orx.MetaAttack("COMBO1","GM7_AXE")





######################################################
#
#        - Attacks themselves -
#
######################################################

# *Name of NEW attack (anm name itself , group name or metagroup)
# *Keys
#       R , L , F , B -> Control keys
#       A -> Attack 
#       D -> Defense(block)
#     
# -->Keys Modifiers
#       a+b . Simultaneous press
#       !c . Should not be pressed
#       &d . Should be already pressed
# *Previous Historial
#       "GA,GA,GM,GGF"
# *Previous NEGATIVE historial
#       +/- idem b4
#
#
######################################################


#COMBOARRIBA1
orx.AllowAttack("GM12_1H","A+R","","GM12_1H","","1H")
orx.AllowAttack("GM12_1H","&A+R","","GM12_1H","","1H")


#COMBODERECHA1
orx.AllowAttack("GM14_1H","A+L","","GM14_1H","","1H")
orx.AllowAttack("GM14_1H","&A+L","","GM14_1H","","1H")


#COMBOIZQUIERDA1
orx.AllowAttack("GM19_1H","A+B","","GM19_1H","","1H")
orx.AllowAttack("GM19_1H","&A+B","","GM19_1H","","1H")


#COMBOABAJO1
orx.AllowAttack("GM18_1H","A+F","","GM18_1H","","1H")
orx.AllowAttack("GM18_1H","&A+F","","GM18_1H","","1H")


#GOLPESINARMA1
orx.AllowAttack("GM22_NO","A","","COMBO1,COMBO1","","NO")

#GOLPESINARMA2
orx.AllowAttack("GM20_NO","A+B","","COMBO1","","NO")
orx.AllowAttack("GM20_NO","&A+B","","COMBO1","","NO")

#GOLPESINARMA3
orx.AllowAttack("GM21_NO","A+F","","COMBO1","","NO")
orx.AllowAttack("GM21_NO","&A+F","","COMBO1","","NO")


###COMBOHACHATORPE2
orx.AllowAttack("GM7_AXE","A+R","","","GM7_AXE_Window","AXE")
orx.AllowAttack("GM7_AXE","&A+R","","","GM7_AXE_Window","AXE")

#COMBOHACHATORPE1
orx.AllowAttack("GM1_AXE","A","","","GM1_AXE_Window","AXE")

#COMBOESPADATORPE3
orx.AllowAttack("GM4_2W","A","GM3_2W","","GM3_2W_Window","2W")

#COMBOESPADATORPE2
orx.AllowAttack("GM3_2W","A","","COMBO1,COMBO1,COMBO1","GM4_2W_Window","2W")

#COMBOLANZATORPE2
orx.AllowAttack("GM6_SP","A","GM5_SP","","GM5_SP_Window","SP")

#COMBOLANZATORPE1
orx.AllowAttack("GM5_SP","A","","COMBO1,COMBO1,COMBO1","GM6_SP_Window","SP")


orx.AllowAttack("GM16_1H","R+L","GIM_1H","","GI_1H_Window","1H")   ## 16 windmill

#GI
orx.AllowAttack("G1_1H","A","","GIM_1H","GI_1H_Window","1H")




print"loaded new Orc(x) combos"














