import Bladex
import Enm_Def
import Reference
import AllyCombat
import Combat
import AuxTran
import AniSound
import pdb
import BCopy
import math
import whrandom
import Actions
import Interpolator
import CharStats
import ItemTypes
import AuxFuncs
import Sparks
import Objects
import InitDataField
import Blood
import dust
import B3DLib
import Damage
import darfuncs
import GenFX
import OnOff
import DMusic
import ObjStore
import Change
import ScorerActions
import Basic_Funcs
import AniSound
import MenuText
import XtraAnimSounds

#
# Boolean value
#
TRUE = 1==1
FALSE = not TRUE


ATK_UNIQUE=0
ATK_RANDOM=1
ATK_SEQUENTIAL=2


new_combo_sound = Bladex.CreateSound('..\\..\\Sounds\\sesgado-lava.wav', 'NewComboSound')
new_combo_sound.Volume=1.0
new_combo_sound.MinDistance=5000
new_combo_sound.MaxDistance=20000


###########################################################################################################################################################


class NewPlayer (Basic_Funcs.PlayerPerson):
	def __init__(self, me):
		
		Basic_Funcs.PlayerPerson.__init__(self, me)
		
		inv = me.GetInventory()
		inv.maxObjects = 30  # experiment (seems OK.....)
		
		me.NewComboFunc=self.NewNewCombo
		
		
	def NewNewCombo(self,EntityName,ComboName):
		
		import GameText
			
		me = Bladex.GetEntity(EntityName)
		if EntityName<>"Player1":
			return
		GameText.WriteTextAux(MenuText.GetMenuText("New Attack"),2.0,255,255,255,[],None,1)
		new_combo_sound.Stop()
		new_combo_sound.PlayStereo()
		
		
#########################################################################################################################################################
		
		


class Orc (NewPlayer):
	def __init__(self, me):
		NewPlayer.__init__(self, me)
			
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		XtraAnimSounds.AddXtraOrkSounds(EntityName)



	
class DarkOrc (NewPlayer):
	def __init__(self, me):
		NewPlayer.__init__(self, me)
			
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		XtraAnimSounds.AddXtraDarkOrcSounds(EntityName)
		
				
		
		
class GoldOrc (NewPlayer):
	def __init__(self, me):
		NewPlayer.__init__(self, me)
		
		me.MeshName="Gold_Ork"
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		XtraAnimSounds.AddXtraGoldOrcSounds(EntityName)
	
		

	
class ChiefOrc (NewPlayer):
	def __init__(self, me):
		NewPlayer.__init__(self, me)
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		XtraAnimSounds.AddXtraChiefOrcSounds(EntityName)
	
	
	
	
	
	
	
	
	

########################################################################################################################################################
