import Bladex
import ItemTypes
import Interpolator
import CharStats
import ItemTypes
import AuxFuncs
import Sparks
import Objects
import InitDataField
import Blood
import dust
import B3DLib
import Damage
import darfuncs
import GenFX
import Reference
import Sounds
import MenuText
import Actions
import Auras
import math
import BCopy
import whrandom
import Gems
import BUIx	
import ScorerWidgets
import Ally_Def
import ObjStore
import netgame
import GameStateAux
import Change

import Language

########################################################################################################################

TRUE = 1
FALSE = 0

#######################################################################################################################


class NewTravelBook(BUIx.B_RectWidget):
	def __init__(self,Parent,Menudesc,StackMenu,VertPos=0):
		import Language
		import Raster
		self.index = 1
		self.images = []
		self.vidw = 1
		self.vidh = 1
		char = Bladex.GetEntity("Player1")
		Raster.UnifyRenderBuffers()
		from NewOrcCityMenu import PlayerName
		
		
		self.AddImage("..\\..\\Maps\\NewOrcCity\\ComboScreens\\credits.jpg")
		
		self.AddImage("..\\..\\Maps\\NewOrcCity\\ComboScreens\\"+ PlayerName +"\\combos.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current +"\\Items\\plantillaGitems.jpg")
		
	
		
		BUIx.B_RectWidget.__init__(self,Parent,Menudesc["Name"],self.vidw,self.vidh)
		self.Selected=0
		self.Solid=0
		self.Border=0
		self.SetDrawFunc(self.Draw)
		self.SndCorreGema=Bladex.CreateSound("..\\..\\Sounds\\M-DESENFUNDA-PIEDRA1.wav","Chanje")
		self.SndCorreGema.Volume=0.4
		self.SndCorreGema.MinDistance=1000000.0
		self.SndCorreGema.MaxDistance=2000000


	def AddImage(self, file):
		import BBLib
		image = BBLib.B_BitMap24()
		image.ReadFromFile(file)
		self.images.append(image)


	def Draw(self,x,y,time):
		import Menu
		import Raster
		char = Bladex.GetEntity("Player1")
		x,y = Raster.GetSize()
		Raster.SetPosition((x - 640)/2, (y - 480)/2)
		if self.index < 0:
			self.index = len(self.images) - 1
		if self.index > len(self.images) - 1:
			self.index = 0
		Raster.DrawImage(640,480,"BGR","Normal",self.images[self.index].GetData())
		self.DefDraw(x,y,time)

	def FinalRelease(self):
		BUIx.B_RectWidget.FinalRelease(self)

	def AcceptsFocus(self):
		return 1

	def IncMenuItem(self):
		self.SndCorreGema.PlayStereo()
		self.index = self.index + 1

	def DecMenuItem(self):
		self.SndCorreGema.PlayStereo()
		self.index = self.index - 1

	def GetFocus(self):
	    return self

	def ActivateItem(self,activate):
		import Menu
		Menu.ActivateMenu()
		
		
def ExecTravelBook():
	print("travel book activated")
	import Menu
	import GameText
	import Scorer
	import acts
	GameText.AbortText()
	if not Menu.MENU_PREACTIVATED:
		try:
			Menu.TB_ACTIVATED=1
		except:
			pass
		Menu.MENU_PREACTIVATED = 1
		pepote = Menu.Desc1
		Menu.Desc1={"Name":"TopMenu","FrameKind":NewTravelBook,"ListDescr":[{"Name":"Back","Kind":NewTravelBook}]}
		Menu.ActivateMenu()
		Menu.Desc1 = pepote
		Scorer.HideTBS()
		for kn in acts.GetKeyList("Turn Left"):
			if kn!="Left":
				Bladex.AssocKey("Menu Dec","Keyboard",kn)
		for kn in acts.GetKeyList("Turn Right"):
			if kn!="Right":
				Bladex.AssocKey("Menu Inc","Keyboard",kn)
	
	

	
				
# call from DefFuncs				
def EnableTravelBook():
	Bladex.AddBoundFunc("LaunchTravel",ExecTravelBook)
	import acts
	Bladex.RemoveBoundFunc("LaunchTravel",acts.ExecTravelBookNP)
	print("travel book save")



		
##########################################################################################################################################################

class PlayerDalWeapon(ItemTypes.PersistantItemType):
	Name=""
	Speed= 15000.0
	Spin= -0.8
	Axis= (1.0, 0.0, 0.0)
	OwnerName= "Player1"
	C= None
	TimeWeaponStarted= None
	R= None
	Rn= None
	w= None
	RSQdist=None
	WeaponActive= 0
	grasped= 0
	tFinished= None
	Weapon= None
	ThrownBy="Player1"
	Target= None
	Time2Grasp=0.4
	spinsound=None
	WeaponFX=None
	
	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon= 1
		self.Name= me.Name
		#self.Speed= 12000.0
		self.Speed= 15000.0
		self.Spin= -0.8
		self.Axis= (1.0, 0.0, 0.0)
		self.OwnerName= "Player1"
		self.C= None
		self.TimeWeaponStarted= None
		self.R= None
		self.Rn= None
		self.w= None
		self.RSQdist=None
		self.WeaponActive= 0
		self.grasped= 0
		self.tFinished= None
		self.Weapon= None
		self.ThrownBy="Player1"
		self.Target= None
		self.Time2Grasp=0.4
		# Create a looped sound
		SoundName= "..\\..\\Sounds\\vueltas-en-el-aire.wav"
		self.spinsound= Bladex.CreateEntity (me.Name+"LoopSound", "Entity Sound", 0, 0, 0)
		self.spinsound.SetSound (SoundName)
		self.spinsound.MinDistance=5000
		self.spinsound.MaxDistance=30000
		me.Link(self.spinsound)
		GenFX.AddWeaponFX(me.Name, self)
		
		

	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		ThrownByName=""
		WeaponName=""
		SpinSoundName=""
		if self.Weapon: WeaponName=self.Weapon.Name
		if self.ThrownBy: ThrownByName=self.ThrownBy.Name
		if self.spinsound: SpinSoundName=self.spinsound.Name
		
		state[1]["PlayerDalWeapon"]=(self.Name,
								self.Speed,
								self.Spin,
								self.Axis,
								self.OwnerName,
								self.C,
								self.TimeWeaponStarted,
								self.R,
								self.Rn,
								self.w,
								self.RSQdist,
								self.WeaponActive,
								self.grasped,
								self.tFinished,
								WeaponName,
								ThrownByName,
								self.Target,
								self.Time2Grasp,
								SpinSoundName,
								self.WeaponFX)
		
		return state
	
	def __setstate__(self,parm):
		PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["PlayerDalWeapon"]
			ThrownByName=""
			WeaponName=""
			SpinSoundName=""
			
			(self.Name,
			self.Speed,
			self.Spin,
			self.Axis,
			self.OwnerName,
			self.C,
			self.TimeWeaponStarted,
			self.R,
			self.Rn,
			self.w,
			self.RSQdist,
			self.WeaponActive,
			self.grasped,
			self.tFinished,
			WeaponName,
			ThrownByName,
			self.Target,
			self.Time2Grasp,
			SpinSoundName,
			self.WeaponFX)= parms
			
			if WeaponName: self.Weapon=Bladex.GetEntity(WeaponName)
			if ThrownByName: self.ThrownBy=Bladex.GetEntity(ThrownByName)
			if SpinSoundName: self.spinsound=Bladex.GetEntity(SpinSoundName)
			
		else:
			self.Name="Unnamed"


	
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return

		#if owner.Kind!="DalGurak":
		#	raise AttributeError
		
		if owner.ActiveEnemy:
			enemy = Bladex.GetEntity(owner.ActiveEnemy)
			if enemy and enemy.Person:
				TargetPos= enemy.GraspPos ("ViewPoint")
		else:
			TargetPos= owner.Rel2AbsPoint(0,-10000.0,0.0)
		

		if weapon.TestHit:
			return

		Actions.RemoveFromInventory (owner, weapon, EventName)
		
		SourcePos= weapon.Position
		
		

		# target one metre past the enemies head
		offsetx,offsety,offsetz= B3DLib.Scale(B3DLib.Normalize((TargetPos[0]-SourcePos[0], TargetPos[1]-SourcePos[1], TargetPos[2]-SourcePos[2])), 1000.0)
		TargetPos= TargetPos[0]+offsetx, TargetPos[1]+offsety, TargetPos[2]+offsetz

		self.C= (SourcePos[0]+TargetPos[0])*0.5, (SourcePos[1]+TargetPos[1])*0.5, (SourcePos[2]+TargetPos[2])*0.5
		self.TimeWeaponStarted= Bladex.GetTime()
		self.R= SourcePos[0]-self.C[0], SourcePos[1]-self.C[1], SourcePos[2]-self.C[2]
		self.RSQdist= abs(self.R[0]**2.0+self.R[1]**2.0+self.R[2]**2.0)
		moduloR= math.sqrt(self.RSQdist)
		scale= (moduloR/8.0) / math.sqrt(self.R[2]*self.R[2]+self.R[0]*self.R[0])
		self.Rn= -self.R[2]*scale, 0.0, self.R[0]*scale
		self.w = self.Speed / moduloR
		Bladex.SetAfterFrameFunc("DalWeaponMoveWeapon", self.MoveWeapon)
		self.WeaponActive= 0
		self.grasped= 0
		self.tFinished= Actions.TWOPI/self.w
		self.Weapon= weapon
		self.ThrownBy= owner  # this pointer may not be valid
		self.Time2Grasp= Bladex.GetAnimationDuration("Dgk_catch")*0.239 # currently 0.239 is the point for the catch
		self.spinsound.PlaySound(-1)
		weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
		InitDataField.Initialise(weapon)
		
	def MoveWeapon (self, time):
		self.Weapon.RemoveFromWorld()
		t= time-self.TimeWeaponStarted
		wt= self.w*t
		cos_wt= math.cos(wt)
		sin_wt= math.sin(wt)
		P= self.R[0]*cos_wt + self.Rn[0]*sin_wt, self.R[1]*cos_wt + self.Rn[1]*sin_wt, self.R[2]*cos_wt + self.Rn[2]*sin_wt
		self.Weapon.Position= P[0]+self.C[0], P[1]+self.C[1], P[2]+self.C[2]
		
		if wt>=Actions.TWOPI:
			owner=Bladex.GetEntity(self.OwnerName)
			if owner:
				inv= owner.GetInventory()
				inv.AddWeapon(self.Weapon.Name)
				if not owner.InvRight:
					inv.LinkRightHand(self.Weapon.Name)
			Bladex.RemoveAfterFrameFunc("DalWeaponMoveWeapon")
		elif wt >= Actions.PI*1.5:
			if self.WeaponActive:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
		elif wt >= Actions.PI and self.WeaponActive:
			owner=Bladex.GetEntity(self.OwnerName)
			if owner and owner.SQDistance2(self.Weapon) < self.RSQdist/2.0:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
		elif wt >= Actions.PI*0.5:
			if not self.WeaponActive:
				self.Weapon.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_START_TRAIL,0,0)
				self.WeaponActive= 1
		
		if (not self.grasped) and t+self.Time2Grasp >= self.tFinished:
			self.grasped=1
			self.spinsound.StopSound()
			owner=Bladex.GetEntity(self.OwnerName)
			if owner and owner.Life>0:
				owner.Wuea=Reference.WUEA_ENDED
				owner.InterruptCombat()
				owner.LaunchAnmType("catch")
			else:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
				self.Weapon.Impulse(0,10,0)
				Bladex.RemoveAfterFrameFunc("DalWeaponMoveWeapon")
		# Angular velocity
		self.Weapon.RotateRel(0.0, 0.0, 0.0 ,self.Axis[0],self.Axis[1],self.Axis[2],self.Spin,1)
		
		
##########################################################################################################################################################

class CyanideStar(ItemTypes.ActivateableSpecialWeapon):
	
	def __init__(self, me):
		ItemTypes.ActivateableSpecialWeapon.__init__(self, me)
		self.SpecialExtraDamage= [["Venom", +22],]
		me.Weapon= 1
		self.Age= 0
		self.FadeTime= 1.0
		self.Speed= 10000.0
		self.missileName= ""
		self.LastHitTime=-1
		self.AuxFuncsData=None
		self.IChuckedIt=0
		
		self.WhileSound=Bladex.CreateEntity (me.Name+"MissileLoopSound", "Entity Sound", 0, 0, 0)
		self.WhileSound.SetSound("..\\..\\Sounds\\vueltas-en-el-aire.wav")
		self.WhileSound.MinDistance=5000
		self.WhileSound.MaxDistance=30000
		me.Link(self.WhileSound)
		
		self.ImpactSound=Bladex.CreateEntity (me.Name+"MissileImpactSound", "Entity Sound", 0, 0, 0)
		self.ImpactSound.SetSound("..\\..\\Sounds\\energy-ball-impact.wav")
		self.ImpactSound.MinDistance=5000
		self.ImpactSound.MaxDistance=30000
		
		self.OwnerName=""


	def __getstate__(self):
		state= ItemTypes.ActivateableSpecialWeapon.__getstate__(self)
		state[1]["CyanideStar"]=   (self.Age,
									self.FadeTime,
									self.Speed,
									self.missileName,
									self.LastHitTime,
									self.WhileSound.Name,
									self.ImpactSound.Name,
									self.AuxFuncsData,
									self.OwnerName
									)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.ActivateableSpecialWeapon.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["CyanideStar"]
			self.Age=parms[0]
			self.FadeTime= parms[1]
			self.Speed=parms[2]
			self.missileName= parms[3]
			self.LastHitTime= parms[4]
			self.WhileSound= Bladex.GetEntity(parms[5])
			self.ImpactSound= Bladex.GetEntity(parms[6])
			self.AuxFuncsData= parms[7]
			self.OwnerName=  parms[8]
		else:
			self.Age=0
			self.FadeTime= 1.0
			self.Speed= 10000.0
			self.missileName= ""
			self.LastHitTime=-1
			self.WhileSound= Bladex.GetEntity(self.Name+"MissileLoopSound")
			self.ImpactSound= Bladex.GetEntity(self.Name+"MissileImpactSound")
			self.AuxFuncsData= None
			self.OwnerName= ""
		
		weapon=  Bladex.GetEntity(self.Name)
		if weapon:
			weapon.OnStopFunc=self.RestorePickup
			
		
		if self.missileName:
			missile= Bladex.GetEntity(self.missileName)
			if missile:
				missile.InflictHitFunc= self.SurikenInflictHitFunc
				missile.OnHitFunc= self.WeaponOnHitFunc
				if weapon:
					weapon.InflictHitFunc= self.SurikenInflictHitFunc
			else:
				print "Missile "+self.missileName+" unavailable for linking...."


	def RestorePickup(self, EntityName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		Reference.EntitiesObjectData[weapon.Name]= [Reference.OBJ_ITEM]
		weapon.Data=Suriken(weapon)
		print"pickup restored"
	
	
	def RestorePickupAfterObjHit(self, EntityName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.2,weapon.Impulse,(0.0,1.0,0.0,))
		self.RestorePickup(EntityName)
		print"pickup restored after hit person"
	
	

	
	def DropReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return		
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return	
		if weapon.TestHit:
			return
		Actions.RemoveFromInventory (owner, weapon, EventName)
		ix, iy, iz = owner.Rel2AbsVector(-1000.0, -1500.0, 0.0)
		weapon.Impulse(ix, iy, iz)
		weapon.ExcludeHitFor(owner)
		owner.DelAnmEventFunc(EventName)
		Reference.EntitiesObjectData[weapon.Name]= [Reference.OBJ_ITEM]
		weapon.Data=Suriken(weapon)
	
	
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return
		
		if weapon.TestHit:
			return
		weapon.ExcludeHitFor(owner)
		self.IChuckedIt=1
		Actions.RemoveFromInventory (owner, weapon, EventName)
		self.Age= self.Age+1
		x,y,z= weapon.Position
		missile= Bladex.CreateEntity(self.Name+"_Missile_"+`self.Age`, "Entity Magic Missile", x,y,z)
		InitDataField.Initialise(missile)
		missile.CastShadows=0
		missile.Color=0, 0, 0
		self.missileName= missile.Name
		self.weaponName= weapon.Name
		# Set the velocity of the missile ## add xtra targeting data here*****
		
		list=[]
		pj_dir=owner.Rel2AbsVector(0.0,-1.0,0.0)
		abovehead_pos=owner.Rel2AbsPoint(0.0,0.0,6000)
		
		tx,ty,tz= owner.Rel2AbsPoint(0,-30000.0,0.0)
		
		if owner.ActiveEnemy:
			enemy= Bladex.GetEntity(owner.ActiveEnemy)
			if enemy and enemy.Person:
				tx1,ty1,tz1= enemy.GraspPos ("ViewPoint")
				tx2,ty2,tz2= enemy.Position
				tx= (tx1+tx2)/2.0; ty= (ty1+ty2)/2.0; tz= (tz1+tz2)/2.0; 
			else:
				tx,ty,tz= owner.Rel2AbsPoint(0,-30000.0,0.0)
				
				
				
		else:
			list=Bladex.GetEnemiesVisibleFrom(abovehead_pos,50000,pj_dir,0.0)
			for id in list:
				enemy = Bladex.GetEntity(id)
				if enemy and enemy.Person:
					#tx1,ty1,tz1= enemy.GraspPos ("ViewPoint")
					tx1,ty1,tz1= enemy.Rel2AbsPoint(0,0,1000)# target head on humans 8/
					tx2,ty2,tz2= enemy.Position
					tx= (tx1+tx2)/2.0; ty= (ty1+ty2)/2.0; tz= (tz1+tz2)/2.0; 
					break
					print"target set for enemy on high wall"
				else:
					tx,ty,tz= owner.Rel2AbsPoint(0,-30000.0,0.0)
					
		
			
		
		
		angley= -B3DLib.GetYAngle(tx-x,ty-y,tz-z)
		vx,vy,vz= owner.Rel2AbsVector(0.0, -math.cos(angley)*self.Speed, -math.sin(angley)*self.Speed)
		
		anglexz= B3DLib.Pos2PosXZAngle(x,y,z,tx,ty,tz)
		diff_angle= min (max (B3DLib.DiffAngle(anglexz, owner.Angle), -Actions.FACINGANGLE), Actions.FACINGANGLE)
		cos_ang= math.cos(diff_angle); sin_ang= math.sin(diff_angle)
		vx,vy,vz=  (vx*cos_ang-vz*sin_ang, vy, vx*sin_ang+vz*cos_ang)
		
		# Reorient and Link the sword to the missile
		weapon.Orientation=0.707107,0.707107,0.000000,0.000000 ############
		weapon.RotateRel(0,0,0, 0,-1,0, 3.14159/2.0)
		weapon.RotateRel(0,0,0, -1,0,0, (3.0*3.14159/2.0)-anglexz)
		weapon.RotateRel(0,0,0, 0,-1,0, -angley)
		
		weapon.Position=0, 0, 0
		missile.Link(weapon)
		
		AuxFuncs.ColorObject(missile.Name, missile.Color, (3,7,5), self.FadeTime*2.0)
		missile.Velocity= vx,vy,vz
		
		
		
		self.WhileSound.PlaySound(-1)
		
		Reference.EntitiesObjectData[missile.Name]= Reference.DefaultObjectData[weapon.Kind]
		missile.OnHitFunc= self.WeaponOnHitFunc
		missile.Data.ThrownBy = owner  		# this pointer may not be valid
		 	
		#missile.InflictHitFunc= self.SurikenInflictHitFunc
		weapon.InflictHitFunc= self.SurikenInflictHitFunc
		weapon.OnStopFunc=self.RestorePickup
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.2,weapon.MessageEvent,(Reference.MESSAGE_START_WEAPON,0,0,))
		
		
		
	def SurikenInflictHitFunc(self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		#if self.missileName:
		#	self.WeaponOnHitFunc (self.missileName, VictimName)
		if self.weaponName:
			self.WeaponOnHitFunc (self.weaponName, VictimName)
			
			
	
	def DeleteMissileData(self):
		if self.missileName and Reference.EntitiesObjectData.has_key(self.missileName):
			del Reference.EntitiesObjectData[self.missileName]
			self.missileName= ""
			
			
			
			
	def WeaponOnHitFunc (self, EntityName, hit_entity):
		time=Bladex.GetTime()
		if time==self.LastHitTime:
			return
		
			
		missile= Bladex.GetEntity(EntityName)
		weapon= Bladex.GetEntity(self.Name)
		if missile: 
			missile.Data.InflictHitFunc=0
		if weapon and missile:
			Bladex.AddScheduledFunc(time, self.DeleteMissileData, (), "DeleteMissileData")
			missile.Unlink(weapon)
			missile.Stop()
			missile.SubscribeToList("Pin")
			self.WhileSound.StopSound()
			weapon.Alpha= 1.0
			weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
			print"FINISHED"
		#weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
		if hit_entity:
			
			thing=Bladex.GetEntity(hit_entity)
			if thing.Person:
				print "hitting"+hit_entity
				self. RestorePickupAfterObjHit(EntityName)
			else:
				
				self.RestorePickupAfterObjHit(EntityName)
				print  "hitting"+hit_entity
		else:
			print "hitting world"
			self.RestorePickup(EntityName)#########
		self.IChuckedIt=0
			
			
			
			
			
########################################################################################
	

class Suriken (ItemTypes.PersistantItemType):

	def __init__(self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon= 1
		self.Name= me.Name
		self.Age = 0
		self.Hit = 0
		self.OwnerName=""
		#try:
		#	AddXtraWeaponFX(me.Name, self)
		#except:
		#	print"no FX on Suriken"
		
		Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_ITEM]
		Reference.StackObjects['Suriken']= 8
		weapon= Bladex.GetEntity(self.Name)
		InitDataField.Initialise(weapon)
		
		
		if Language.Current == "Spanish":
           		MenuText.ForeingDict['Rocket'] = 'Suriken'
		Reference.EntitiesSelectionData[self.Name]=(8,4000,MenuText.GetMenuText('Suriken'))

		me.UseFunc = self.UseSuriken

		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["Suriken"]=   (				self.Name,
									self.Age,
									self.Hit,
									self.OwnerName
								)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["Suriken"]
			self.Name=parms[0]
			self.Age=parms[1]
			self.Hit= parms[2]
			self.OwnerName=  parms[3]		
		else:
			self.Name=""
			self.Age=0
			self.Hit= 0
			self.OwnerName= "Player1"
			
	

	def UseSuriken(self, DiskName, TipoUso):
		disk=Bladex.GetEntity(DiskName)
		if TipoUso == Actions.USE_FROM_INV:
		   	ownerName= disk.Data.UsedBy
		   	Actions.FreeBothHands(ownerName)
		   	owner=Bladex.GetEntity(ownerName)
		   	if owner and owner.Life >0:
		   		owner.Data.throw_weapon = None
      	              	inv=owner.GetInventory()
      	              	inv.RemoveObject(DiskName)
   	              	Change.ChangeObject(ownerName, DiskName, self.FinishChange)
   	        elif TipoUso == Actions.USE_FROM_TAKE:
		   	Actions.StdUse (ownerName)


	def FinishChange(self, EntityName,ObjectName):
		disk=Bladex.GetEntity(ObjectName)
		disk.Data=CyanideStar(disk)
	       	Reference.EntitiesObjectData[ObjectName]= [Reference.OBJ_STANDARD,   100, 0, 1.0, Reference.THR_SPINNING, [],["Venom", +10.0]]
   
  




def CreateSuriken (name,pos):
	skn=Bladex.CreateEntity(name,"Suriken",pos[0],pos[1],pos[2], "Weapon")
	skn.Scale=2.0
	skn.Orientation=(0.236,0.1047,0.0,0.966)
	skn.Impulse(0,0,0)
	skn.Data=Suriken(skn)
	return skn.Data
	
###########################################################################################################################################################

	
	
	
	

	
	
		
		
			






	
	


		
		
			




	