import AniSound
import Basic_Funcs
import Actions
import ItemTypes
import Reference
import Sparks
import PlayerTypes




#################################################################################################
# New Races  #          ##
##############          ##
# Name      Int Name    ##
# ChiefOrk / Crk        ## Material int name CHRKF/CHRKR = Front/Back. Add _W for wounded skin
#                       ##
#################################################################################################
#                       ##
#  Name      IntName    ##
#  Orx   /   Orx        ## Material int name ORX_A/ORX_B  = Front/Back. Add _W for wounded skin
#                       ##
#################################################################################################
#                       ##
#  Name      IntName    ##
#  Gold_Orx/ Grx        ## Material int name GORX_A/GORX_B  = Front/Back. Add _W for wounded skin
#                       ##
#################################################################################################
#################################################################################################
#                       ##
#  Name      IntName    ##
#  Barbarian_E/ Erc     ## Material int name BAREF/BARER  = Front/Back. Add _W for wounded skin
#                       ##
#################################################################################################




############################################################################################################################################################
## These tables must be declared before creating new player char # put same in DefFuncs for savegame 
from CharData import CharMaxLifeValue
from CharData import CharDamageData
from CharData import CharDefenseData
from CharData import CharResistances
from CharData import CharExperienceCost
from CharData import CharExperienceReward
from CharData import CharAccuracy


CharMaxLifeValue['Chief_Ork']=[   100,    200,    300,    400,    600,    800,   1000,   1400,   1800,   2200,   2600,   3000,   3400,   3800,   4200,   4600,   5000,   5400,   5800,   6200]
CharDamageData['Chief_Ork']=  [     1,      2,      4,      6,      8,     10,     12,     14,     16,     18,     20,     22,     24,     26,     28,     30,     32,     34,     36,     38]
CharDefenseData['Chief_Ork']= [     1,      2,      4,      6,      8,     10,     12,     14,     16,     18,     20,     22,     24,     26,     28,     30,     32,     34,     36,     38]
CharExperienceCost['Chief_Ork']=[    50,    100,    200,    400,    800,   1600,   3200,   6400,  12800,  25600,  51200, 102400, 204800, 409600, 819200,1638400,3276800,6553600,13107200,26214400]
CharExperienceReward['Chief_Ork']= [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] # calibrate later
CharAccuracy['Chief_Ork']= [   0.1,    0.1,    0.2,    0.2,    0.3,    0.3,    0.4,    0.4,    0.5,    0.5,    0.6,    0.6,    0.6,    0.7,    0.7,    0.7,    0.8,    0.8,    0.9,    0.9]


CharMaxLifeValue['Orx']=[   100,    200,    300,    400,    600,    800,   1000,   1400,   1800,   2200,   2600,   3000,   3400,   3800,   4200,   4600,   5000,   5400,   5800,   6200]
CharDamageData['Orx']=  [     1,      2,      4,      6,      8,     10,     12,     14,     16,     18,     20,     22,     24,     26,     28,     30,     32,     34,     36,     38]
CharDefenseData['Orx']= [     1,      2,      4,      6,      8,     10,     12,     14,     16,     18,     20,     22,     24,     26,     28,     30,     32,     34,     36,     38]
CharExperienceCost['Orx']=[    50,    100,    200,    400,    800,   1600,   3200,   6400,  12800,  25600,  51200, 102400, 204800, 409600, 819200,1638400,3276800,6553600,13107200,26214400]
CharExperienceReward['Orx']= [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] # calibrate later
CharAccuracy['Orx']= [   0.1,    0.1,    0.2,    0.2,    0.3,    0.3,    0.4,    0.4,    0.5,    0.5,    0.6,    0.6,    0.6,    0.7,    0.7,    0.7,    0.8,    0.8,    0.9,    0.9]


CharMaxLifeValue['Gold_Orx']=[   100,    200,    300,    400,    600,    800,   1000,   1400,   1800,   2200,   2600,   3000,   3400,   3800,   4200,   4600,   5000,   5400,   5800,   6200]
CharDamageData['Gold_Orx']=  [     1,      2,      4,      6,      8,     10,     12,     14,     16,     18,     20,     22,     24,     26,     28,     30,     32,     34,     36,     38]
CharDefenseData['Gold_Orx']= [     1,      2,      4,      6,      8,     10,     12,     14,     16,     18,     20,     22,     24,     26,     28,     30,     32,     34,     36,     38]
CharExperienceCost['Gold_Orx']=[    50,    100,    200,    400,    800,   1600,   3200,   6400,  12800,  25600,  51200, 102400, 204800, 409600, 819200,1638400,3276800,6553600,13107200,26214400]
CharExperienceReward['Gold_Orx']= [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] # calibrate later
CharAccuracy['Gold_Orx']= [   0.1,    0.1,    0.2,    0.2,    0.3,    0.3,    0.4,    0.4,    0.5,    0.5,    0.6,    0.6,    0.6,    0.7,    0.7,    0.7,    0.8,    0.8,    0.9,    0.9]


############################################################################################################################################################



MapName=0
ActualMapName="Shalatuwar"



try:
	execfile("../../Config/NewOrcCity.cfg")
except:
	pass

InitPos= 0, 0, 0


if MapName==-1:
	InitPos= (2700, 48090, -900)
	ActualMapName="Shalatuwar"
elif MapName==1:
	InitPos= (-118900,-7100,-32000)
	ActualMapName="Kashgar"

#elif MapName=="AlFarum":

else:
	ActualMapName="AlFarum"
	InitPos= (-43000,9000,-139000)



import NUOrkData   
import NUDarkOrkData  
import NUGoldOrkData  
import NUGoldOrkData  


if PlayerName == "Orc":
	if os.path.exists ("../../Config/OrxInst.cfg"):
		char=Bladex.CreateEntity("Player1","Orx", InitPos[0], InitPos[1], InitPos[2], "Person")
		char.Level=13
		char.Data=PlayerTypes.Orc(char)
		rsw=Bladex.CreateEntity("RHandWP","Martillo",0,0,0,"Weapon")
		lsw=Bladex.CreateEntity("LHandWP","Escudo7",0,0,0,"Weapon")
		Sparks.MakeShield(lsw.Name)
	else:
		char=Bladex.CreateEntity("Player1","Knight_N", InitPos[0], InitPos[1], InitPos[2], "Person")

elif PlayerName == "GoldOrc":
	if os.path.exists ("../../Config/GrxInst.cfg"):
		char=Bladex.CreateEntity("Player1","Gold_Orx", InitPos[0], InitPos[1], InitPos[2], "Person")
		char.Level=12
		char.Data=PlayerTypes.GoldOrc(char)
		rsw=Bladex.CreateEntity("RHandWP","Espadacurva",0,0,0,"Weapon")
		lsw=Bladex.CreateEntity("LHandWP","Escudo4",0,0,0,"Weapon")
		Sparks.MakeShield(lsw.Name)
	else:
		char=Bladex.CreateEntity("Player1","Knight_N", InitPos[0], InitPos[1], InitPos[2], "Person")
	
	
elif PlayerName == "ChiefOrc":
	if os.path.exists ("../../Config/ChiefOrkInst.cfg"):
		import NUChiefOrkData  
		char=Bladex.CreateEntity("Player1","Chief_Ork", InitPos[0], InitPos[1], InitPos[2], "Person")
		char.Level=17
		char.Data=PlayerTypes.ChiefOrc(char)
		rsw=Bladex.CreateEntity("RHandWP","Martillo2",0,0,0,"Weapon")
		lsw=Bladex.CreateEntity("LHandWP","Escudo9",0,0,0,"Weapon")
		Sparks.MakeShield(lsw.Name)
	else:
		char=Bladex.CreateEntity("Player1","Knight_N", InitPos[0], InitPos[1], InitPos[2], "Person")
	
	
elif PlayerName == "DarkOrc":
	char=Bladex.CreateEntity("Player1","Dark_Ork", InitPos[0], InitPos[1], InitPos[2], "Person")
	char.Level=14
	char.Data=PlayerTypes.DarkOrc(char)
	rsw=Bladex.CreateEntity("RHandWP","Ninjato",0,0,0,"Weapon")
	lsw=Bladex.CreateEntity("LHandWP","Escudo3",0,0,0,"Weapon")
	Sparks.MakeShield(lsw.Name)


char.Angle=4.2

char.Data.ResetSounds("Player1")
char.SendTriggerSectorMsgs=1
char.SetOnFloor()
inv=char.GetInventory()

o=Bladex.CreateEntity("WeaponInvPrb3","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
inv.AddBow("WeaponInvPrb3")

o=Bladex.CreateEntity("QuiverInvPrb1","Carcaj",0,0,0)
ItemTypes.ItemDefaultFuncs (o)
inv=char.GetInventory()
inv.AddQuiver("QuiverInvPrb1")



Actions.TakeObject("Player1","RHandWP")
Actions.TakeObject("Player1","LHandWP")





