import Bladex
import EnemyCharTypes
import AllyOrkTypes
import os
import pocimac

##############################################################################################
##### Goodies

ally1=Bladex.CreateEntity("Buddy1","Ork",9638.90986328,-3684.91158422,33865.7216595, "Person")
ally1.Scale=1.0
ally1.Angle=2.210042166
ally1.Level=10
ally1.Data=AllyOrkTypes.AllyOrk(ally1)
o=Bladex.CreateEntity ("Buddy1WP", "Maza2", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Buddy1", "Buddy1WP")
o=Bladex.CreateEntity ("Buddy1SH", "Escudo7", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Buddy1SH")
Actions.TakeObject("Buddy1", "Buddy1SH")
ally1.Data.PutOnHelmet("Buddy1")


ally2=Bladex.CreateEntity("Buddy2","Ork",7638.90963861,-3984.91185901,36265.7217477, "Person")
ally2.Scale=1.0
ally2.Angle=2.82145877067
ally2.Level=12
ally2.Data=AllyOrkTypes.AllyOrk(ally2)
o=Bladex.CreateEntity ("Buddy2WP", "Orksword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Buddy2", "Buddy2WP")
o=Bladex.CreateEntity ("Buddy2SH", "Escudo1", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Buddy2SH")
Actions.TakeObject("Buddy2", "Buddy2SH")
ally2.Data.PutOnHelmet("Buddy2")


ally3=Bladex.CreateEntity("Buddy3","Great_Ork",-23695.3199344,-1584.91185901,14091.2500031, "Person")
ally3.Scale=1.0
ally3.Angle=2.82
ally3.Level=12
ally3.Data=AllyOrkTypes.AllyOrk(ally3)
o=Bladex.CreateEntity ("Buddy3WP", "Espadacurva", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Buddy3", "Buddy3WP")
o=Bladex.CreateEntity ("Buddy3SH", "Escudo1", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Buddy3SH")
Actions.TakeObject("Buddy3", "Buddy3SH")
ally3.Data.PutOnHelmet("Buddy3")



ally4=Bladex.CreateEntity("Buddy4","Ork",-39487.2290962,-1284.91153655,11057.1409029, "Person")
ally4.Scale=1.0
ally4.Angle=4.73705184573
ally4.Level=13
ally4.Data=AllyOrkTypes.AllyOrk(ally4)
o=Bladex.CreateEntity ("Buddy4WP", "Espadacurva", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Buddy4", "Buddy4WP")
o=Bladex.CreateEntity ("Buddy4SH", "Escudo1", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Buddy4SH")
Actions.TakeObject("Buddy4", "Buddy4SH")
ally4.Data.PutOnHelmet("Buddy4")

ally4.AddBayPoint=-39487.2290962,-1284.91153655,11057.1409029
ally4.AddBayPoint=-16213.7942535,-1284.91185901,11282.0024014
ally4.AddBayPoint=-35205.8428294,-1284.91185901,23.9448872555     


#########################################################################################################
###### Baddies

gol1=Bladex.CreateEntity("Golem_stone_5068","Golem_stone",-29852.871532,-4594.68719921,132083.73395, "Person")
gol1.Scale=1.0
gol1.Angle=3.95275643242
gol1.Level=4
EnemyTypes.EnemyDefaultFuncs(gol1)


gol2=Bladex.CreateEntity("Golem_metal_5159","Golem_metal",-43488.7770007,-3994.68681507,41869.0218325, "Person")
gol2.Scale=1.0
gol2.Angle=1.64474476324
gol2.Level=3
EnemyTypes.EnemyDefaultFuncs(gol2)


lch1=Bladex.CreateEntity("Lich_5069","Lich",-46347.9549436,-3981.20360687,130543.933723, "Person")
lch1.Scale=1.0
lch1.Angle=3.62136918028
lch1.Level=11
EnemyTypes.EnemyDefaultFuncs(lch1)

lch2=Bladex.CreateEntity("Lich_5070","Lich",-44747.9549429,-3981.20361176,134343.933724, "Person")
lch2.Scale=1.0
lch2.Angle=2.78
lch2.Level=12
EnemyTypes.EnemyDefaultFuncs(lch2)



o=Bladex.CreateEntity("Cos_5385","Cos",9835.80018609,683.367093151,-25269.4556764, "Person")
o.Scale=1.0
o.Angle=0.221690021937
o.Level=10
EnemyTypes.EnemyDefaultFuncs(o)


o=Bladex.CreateEntity("Cos_5386","Cos",7435.80007958,683.367093151,-25269.455657, "Person")
o.Scale=1.0
o.Angle=5.78310559401
o.Level=11
EnemyTypes.EnemyDefaultFuncs(o)


o=Bladex.CreateEntity("Cos_5387","Cos",7435.77415748,683.381091524,-23469.4629275, "Person")
o.Scale=1.0
o.Angle=0.797056015728
o.Level=12
EnemyTypes.EnemyDefaultFuncs(o)


o=Bladex.CreateEntity("Little_Demon_5388","Little_Demon",25668.8904072,-5331.61683448,35356.1034903, "Person")
o.Scale=1.0
o.Angle=2.38496213503
o.Level=2
EnemyTypes.EnemyDefaultFuncs(o)


o=Bladex.CreateEntity("Little_Demon_5389","Little_Demon",6303.00879773,1868.384033,43162.044313, "Person")
o.Scale=1.0
o.Angle=5.32932937946
o.Level=3
EnemyTypes.EnemyDefaultFuncs(o)


o=Bladex.CreateEntity("Golem_clay_5390","Golem_clay",35089.203181,1405.31312841,24021.7097774, "Person")
o.Scale=1.0
o.Angle=3.31728603781
o.Level=4
EnemyTypes.EnemyDefaultFuncs(o)



o=Bladex.CreateEntity("Spidersmall_5370","Spidersmall",-52846.2557579,3361.56164964,124457.882853, "Person")
o.Scale=1.0
o.Angle=5.74456888773
o.Level=10
EnemyTypes.EnemyDefaultFuncs(o)


o=Bladex.CreateEntity("Spidersmall_5371","Spidersmall",-51846.2557579,3361.56164973,126057.882853, "Person")
o.Scale=1.0
o.Angle=0.187013598394
o.Level=10
EnemyTypes.EnemyDefaultFuncs(o)


lch3=Bladex.CreateEntity("Lich_5372","Lich",-53407.4551632,2518.79639036,137157.001376, "Person")
lch3.Scale=1.0
lch3.Angle=5.67589671592
lch3.Level=16
EnemyTypes.EnemyDefaultFuncs(lch3)
o=Bladex.CreateEntity ("Lich_5372WP", "Femur", 0,0,0, "Weapon")
Actions.TakeObject("Lich_5372", "Lich_5372WP")



o=Bladex.CreateEntity("Little_Demon_5162","Little_Demon",34285.5537327,-3831.61590425,49452.4399408, "Person")
o.Scale=1.0
o.Angle=3.5
o.Level=3
EnemyTypes.EnemyDefaultFuncs(o)





sal1=Bladex.CreateEntity("AllySally1","Salamander",-40000,0,-55000, "Person")
sal1.Scale=1.0
sal1.Angle=1.5
sal1.Level=2
sal1.Data=AllyOrkTypes.RideableSalamander(sal1)
sal1.SetOnFloor()
sal1.Data.MountUp("AllySally1")



sal2=Bladex.CreateEntity("AllySally2","Salamander",-24921, 5414, -84992, "Person")
sal2.Scale=1.0
sal2.Angle=1.5
sal2.Level=5
sal2.Data=AllyOrkTypes.RideableSalamander(sal2)
sal2.SetOnFloor()
sal2.Data.MountUp("AllySally2","Martillo")


sal3=Bladex.CreateEntity("AllySally3","Salamander",-29772, 5059, -89788, "Person")
sal3.Scale=1.0
sal3.Angle=0
sal3.Level=8
sal3.Data=AllyOrkTypes.RideableSalamander(sal3)
sal3.SetOnFloor()
sal3.Data.MountUp("AllySally3","Hacha4")


sal4=Bladex.CreateEntity("AllySally4","Salamander",-6964, -679, -36456, "Person")
sal4.Scale=1.0
sal4.Angle=1
sal4.Level=9
sal4.Data=AllyOrkTypes.RideableSalamander(sal4)
sal4.SetOnFloor()
sal4.Data.MountUp("AllySally4","Orksword")


import NuAnmFact
NuAnmFact.AnmFactRideableSalamander()


kt1=Bladex.CreateEntity("Knight_Traitor1","Knight_Traitor",-13383.4564086,250.711222708,-51739.8611144, "Person")
kt1.Scale=1.0
kt1.Angle=4.08516391681
kt1.Level=8
EnemyTypes.EnemyDefaultFuncs(kt1)
kt1.SetMesh("Mortimer")
o=Bladex.CreateEntity ("Knight_Traitor1WP", "Espadaelfica", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight_Traitor1", "Knight_Traitor1WP")
o=Bladex.CreateEntity ("Knight_Traitor1SH", "Escudo8", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Knight_Traitor1SH")
Actions.TakeObject("Knight_Traitor1", "Knight_Traitor1SH")


kt2=Bladex.CreateEntity("Knight_Traitor2","Knight_Traitor",-11783.4564087,250.711222711,-51139.8611144, "Person")
kt2.Scale=1.0
kt2.Angle=2.4
kt2.Level=11
EnemyTypes.EnemyDefaultFuncs(kt2)
kt2.SetMesh("Mortimer")
o=Bladex.CreateEntity ("Knight_Traitor2WP", "Hacha3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight_Traitor2", "Knight_Traitor2WP")
o=Bladex.CreateEntity ("Knight_Traitor2SH", "Escudo8", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Knight_Traitor2SH")
Actions.TakeObject("Knight_Traitor2", "Knight_Traitor2SH")



kt3=Bladex.CreateEntity("Knight_Traitor3","Knight_Traitor",-29532.5100586,-10849.2884436,-51778.5651592, "Person")
kt3.Scale=1.0
kt3.Angle=0
kt3.Level=7
EnemyTypes.EnemyDefaultFuncs(kt3)
kt3.SetMesh("Mortimer")
o=Bladex.CreateEntity ("Knight_Traitor3WP", "EgyptSword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight_Traitor3", "Knight_Traitor3WP")
o=Bladex.CreateEntity ("Knight_Traitor3SH", "Escudo8", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Knight_Traitor3SH")
Actions.TakeObject("Knight_Traitor3", "Knight_Traitor3SH")




kt4=Bladex.CreateEntity("Knight_Traitor4","Knight_Traitor",-43863.5433494,-9949.28882491,-45400.9220263, "Person")
kt4.Scale=1.0
kt4.Angle=0.5
kt4.Level=7
EnemyTypes.EnemyDefaultFuncs(kt4)
kt4.SetMesh("Mortimer")
o=Bladex.CreateEntity ("Knight_Traitor4WP", "EgyptSword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight_Traitor4", "Knight_Traitor4WP")
o=Bladex.CreateEntity ("Knight_Traitor4SH", "Escudo8", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Knight_Traitor4SH")
Actions.TakeObject("Knight_Traitor4", "Knight_Traitor4SH")


kt5=Bladex.CreateEntity("Knight_Traitor5","Knight_Traitor",-43863.5433494,-9949.28882491,-45400.9220263, "Person")
kt5.Scale=1.0
kt5.Angle=0.5
kt5.Level=7
EnemyTypes.EnemyDefaultFuncs(kt5)
kt5.SetMesh("Mortimer")
o=Bladex.CreateEntity ("Knight_Traitor5WP", "Katana", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight_Traitor5", "Knight_Traitor5WP")




dk1=Bladex.CreateEntity("Dark_Knight_1","Dark_Knight",-14724.1572585,-12205.4516779,88608.4241202, "Person")
dk1.Scale=1.0
dk1.Angle=3.30551352399
dk1.Level=10
dk1.ActionAreaMin=pow(2,14)
dk1.ActionAreaMax=pow(2,15)
dk1.SetOnFloor()
o=Bladex.CreateEntity ("Dark_Knight_1WP", "Espadaromana", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Dark_Knight_1", "Dark_Knight_1WP")
bow=Bladex.CreateEntity("Dark_Knight_1BW","Arco3",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(bow)
Actions.TakeObject(dk1.Name,bow.Name)
quiver=Bladex.CreateEntity("Dark_Knight_1QV","Carcaj",0,0,0)
ItemTypes.ItemDefaultFuncs (quiver)
quiver.Data.SetNumberOfArrows(10, dk1.Name)
Actions.TakeObject(dk1.Name,quiver.Name)
EnemyTypes.EnemyDefaultFuncs(dk1)




dk2=Bladex.CreateEntity("Dark_Knight_2","Dark_Knight",-144.580422493,-4849.28892034,77599.7514098, "Person")
dk2.Scale=1.0
dk2.Angle=2.6
dk2.Level=7
EnemyTypes.EnemyDefaultFuncs(dk2)
o=Bladex.CreateEntity ("Dark_Knight_2WP", "Espadaromana", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Dark_Knight_2", "Dark_Knight_2WP")
o=Bladex.CreateEntity ("Dark_Knight_2SH", "Escudo4", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Dark_Knight_2SH")
Actions.TakeObject("Dark_Knight_2", "Dark_Knight_2SH")



dk3=Bladex.CreateEntity("Dark_Knight_3","Dark_Knight",-14007.8588114,-4749.28882473,102013.258313, "Person")
dk3.Scale=1.0
dk3.Angle=2.6
dk3.Level=7
EnemyTypes.EnemyDefaultFuncs(dk3)
o=Bladex.CreateEntity ("Dark_Knight_3WP", "Espadaromana", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Dark_Knight_3", "Dark_Knight_3WP")
o=Bladex.CreateEntity ("Dark_Knight_3SH", "Escudo4", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Dark_Knight_3SH")
Actions.TakeObject("Dark_Knight_3", "Dark_Knight_3SH")



dk4=Bladex.CreateEntity("Dark_Knight_4","Dark_Knight",10925.734594,-4249.28877729,72113.2748685, "Person")
dk4.Scale=1.0
dk4.Angle=1.2
dk4.Level=8
EnemyTypes.EnemyDefaultFuncs(dk4)
o=Bladex.CreateEntity ("Dark_Knight_4WP", "Espadaromana", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Dark_Knight_4", "Dark_Knight_4WP")
o=Bladex.CreateEntity ("Dark_Knight_4SH", "Escudo7", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Dark_Knight_4SH")
Actions.TakeObject("Dark_Knight_4", "Dark_Knight_4SH")



dk5=Bladex.CreateEntity("Dark_Knight_5", "Dark_Knight",-45598.37513, -13881.5978078, 82647.9367967,"Person")
dk5.Angle=4.71721032169
dk5.Level=4
dk5.ActionAreaMin=pow(2,14)
dk5.ActionAreaMax=pow(2,15)
dk5.SetOnFloor()
potion=Bladex.CreateEntity("Potion10","Pocima100",0,0,0,"Physic")
potion.Scale=1.220190
pocimac.CreatePotion(potion.Name)
Actions.TakeObject(dk5.Name,potion.Name)
sword=Bladex.CreateEntity("Dark_Knight_5WP","Hacha3",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(sword)
Actions.TakeObject(dk5.Name,sword.Name)
bow=Bladex.CreateEntity("Dark_Knight_5BW","Arco3",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(bow)
Actions.TakeObject(dk5.Name,bow.Name)
quiver=Bladex.CreateEntity("Dark_Knight_5QV","CarcajEnvenenado",0,0,0)
ItemTypes.ItemDefaultFuncs (quiver)
quiver.Data.SetNumberOfArrows(10, dk5.Name)
Actions.TakeObject(dk5.Name,quiver.Name)
EnemyTypes.EnemyDefaultFuncs(dk5)


StartMusicAL()






