import Bladex
import Enm_Def
import Reference
import Combat
import Combat
import AuxTran
import AniSound
import pdb
import BCopy
import math
import whrandom
import Actions
import Interpolator
import CharStats
import ItemTypes
import AuxFuncs
import Sparks
import Objects
import InitDataField
import Blood
import dust
import B3DLib
import Damage
import darfuncs
import GenFX
import OnOff
import DMusic
import ObjStore
import GameText
import Change
import ScorerActions
import Basic_Funcs
import def_class
import Enm_Def
import Ally_Def
import Combat
import EnemyTypes
import Auras
import Sounds
import GameStateAux
import Armour
import XtraAnimSounds


TRUE = 1==1
FALSE = not TRUE



##########################################################################################################################
######### Enemy Chars



class Super_Barb (Enm_Def.NPCPerson):
	def __init__(self, me):
		# base class init
		Enm_Def.NPCPerson.__init__(self, me)
		#print "Personage Creado",me.Name,self.changed_func

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosBarbaro(EntityName)
		Reference.EnemiesScorerData[self.Name]=("BarbarianIcon","Bar")
		
		
	# Functions for loading and saving state
	def __getstate__(self):	
		#print "Changed Funcs",self.changed_func
		
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			print "ERROR: Super_Barb.__getstate__(): Base class version differs."
			return NPCPerson_state
		NPCPerson_state[1]["Super_Barb"]=()
		return NPCPerson_state
	
	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Enm_Def.NPCPerson.__setstate__(self,parm)


	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 1.5
			me.BlockingPropensity = 0.7
			me.AttackList = BCopy.deepcopy(Super_BarbAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			

Super_BarbAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

           # dodges:
            [Combat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],

          

            [Combat.ATTACK, 0.05, ("GI_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Attack 
            [Combat.ATTACK, 0.05, ("GM1_1H",),            1200.0, 1800.0, 2500.0, 0.35], # High Attack 
	    [Combat.ATTACK, 0.05, ("GM4_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Low Attack 
	    [Combat.ATTACK, 0.05, ("GM3_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Left Attack 
	    [Combat.ATTACK, 0.05, ("GM2_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Right Attack 
           #combos
            [Combat.ATTACK, 0.12, ("GM26_AXE",), 	  1200.0, 1600.0, 2500.0, 0.35],    #BlindRage
            #[Combat.ATTACK, 0.12, ("GM27_AXE",), 	  1200.0, 1600.0, 2500.0, 0.35],    #Overkill
            #[Combat.ATTACK, 0.09, ("GM12_2H",), 	  1200.0, 1600.0, 2500.0, 0.35],     #Death Sweep
            #[Combat.ATTACK, 0.12, ("GM6_2H",), 	          1200.0, 1600.0, 2500.0, 0.35],      #Speed Kill
            
            [Combat.ATTACK, 0.30, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],

            [Combat.ATTACK, 0.05, ("GI_AXE",),            1500.0, 2500.0, 3500.0, 0.35], # Attack 
	    [Combat.ATTACK, 0.05, ("GM17_AXE",),            1500.0, 2500.0, 3500.0, 0.35], # High Attack 
	    [Combat.ATTACK, 0.05, ("GM28_AXE",),            1500.0, 2500.0, 3500.0, 0.35], # Low Attack 
	    [Combat.ATTACK, 0.05, ("GM21_AXE",),            1500.0, 2500.0, 3500.0, 0.35], # Left Attack 
	    [Combat.ATTACK, 0.05, ("GM19_AXE",),            1500.0, 2500.0, 3500.0, 0.35], # Right Attack 
	    
	    [Combat.ATTACK, 0.05, ("GI_2H",),            1500.0, 2500.0, 3500.0, 0.35], # Attack 
	    [Combat.ATTACK, 0.05, ("GM1_2H",),            1500.0, 2500.0, 3500.0, 0.35], # High Attack 
	    [Combat.ATTACK, 0.05, ("GM10_2H",),            1500.0, 2500.0, 3500.0, 0.35], # Low Attack 
	    [Combat.ATTACK, 0.05, ("GM7_2H",),            1500.0, 2500.0, 3500.0, 0.35], # Left Attack 
	    [Combat.ATTACK, 0.05, ("GM4_2H",),            1500.0, 2500.0, 3500.0, 0.35], # Right Attack 
	    
	    [Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [Combat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],



            [Combat.MOVE,   0.15, Combat.TempMoveInProc,      3000.0,  7000.0, 9000.0, 0.35, 1],
            [Combat.MOVE,   0.05, Combat.TempMoveOutProc,     3000.0,  3000.0, 7000.0, 0.35, 1],

]

############### End Enemy Barb


class Super_Amz (Enm_Def.NPCPerson):
	def __init__(self, me):
		# base class init
		Enm_Def.NPCPerson.__init__(self, me)
		#print "Personage Creado",me.Name,self.changed_func

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0


		
	
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosAmazona(EntityName)
		Reference.EnemiesScorerData[self.Name]=("AmazonIcon","Amz")
		
	
	# Functions for loading and saving state
	def __getstate__(self):	
		#print "Changed Funcs",self.changed_func
		
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			print "ERROR: Super_Amz.__getstate__(): Base class version differs."
			return NPCPerson_state
		NPCPerson_state[1]["Super_Amz"]=()
		return NPCPerson_state
	
	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Enm_Def.NPCPerson.__setstate__(self,parm)

	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 1.5
			me.BlockingPropensity = 0.9 #0.7
			me.AttackList = BCopy.deepcopy(Super_AmzAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00



				
			
Super_AmzAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

           # dodges:
            [Combat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],

            #[Combat.ATTACK, 0.05, ("GM16_1H",),         1200.0, 1800.0, 2500.0, 0.35], # Attack 
	    #[Combat.ATTACK, 0.05, ("GM17_1H",),         1200.0, 1800.0, 2500.0, 0.35], # High Attack 
	    #[Combat.ATTACK, 0.05, ("GM20_1H",),         1200.0, 1800.0, 2500.0, 0.35], # Low Attack 
	    #[Combat.ATTACK, 0.05, ("GM19_1H",),         1200.0, 1800.0, 2500.0, 0.35], # Left Attack 
	    #[Combat.ATTACK, 0.05, ("GM18_1H",),         1200.0, 1800.0, 2500.0, 0.35], # Right Attack 

            [Combat.ATTACK, 0.09, ("GI_SP",),            1200.0, 1800.0, 2500.0, 0.35], # Attack 
	    [Combat.ATTACK, 0.09, ("GM1_SP",),            1200.0, 1800.0, 2500.0, 0.35], # High Attack 
	    [Combat.ATTACK, 0.09, ("GM8_SP",),            1200.0, 1800.0, 2500.0, 0.35], # Low Attack 
	    [Combat.ATTACK, 0.09, ("GM6_SP",),            1200.0, 1800.0, 2500.0, 0.35], # Left Attack 
	    [Combat.ATTACK, 0.09, ("GM3_SP",),            1200.0, 1800.0, 2500.0, 0.35], # Right Attack 
            
           #combos
             [Combat.ATTACK, 0.8, ("GM25_SP",), 	  1200.0, 1600.0, 2500.0, 0.35],    #Nightmare
             [Combat.ATTACK, 0.8, ("GM15_SP",), 	  1200.0, 1600.0, 2500.0, 0.35],    #Whirlwind
            #[Combat.ATTACK, 0.12, ("GM33_SP",), 	  1200.0, 1600.0, 2500.0, 0.35],    #GutWrencher
            #[Combat.ATTACK, 0.12, ("GM31_SP",), 	  1200.0, 1600.0, 2500.0, 0.35],    #Spinslash
            #[Combat.ATTACK, 0.12, ("GM10_SP",), 	  1200.0, 1600.0, 2500.0, 0.35],     #BlindingSlice
            
            [Combat.MOVE,   0.15, Combat.TempMoveInProc,      3000.0,  7000.0, 9000.0, 0.35, 1],
            [Combat.MOVE,   0.05, Combat.TempMoveOutProc,     3000.0,  3000.0, 7000.0, 0.35, 1],
            [Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],

            
]		

########## End Enemy Amz

class Super_Dwf (Enm_Def.NPCPerson):
	def __init__(self, me):
		# base class init
		Enm_Def.NPCPerson.__init__(self, me)
		#print "Personage Creado",me.Name,self.changed_func

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		
	
	
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosEnano(EntityName)
		Reference.EnemiesScorerData[self.Name]=("DwarfIcon","Dwf")
		
		

	# Functions for loading and saving state
	def __getstate__(self):	
		#print "Changed Funcs",self.changed_func
		
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			print "ERROR: Super_Dwf.__getstate__(): Base class version differs."
			return NPCPerson_state
		NPCPerson_state[1]["Super_Dwf"]=()
		return NPCPerson_state
	
	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Enm_Def.NPCPerson.__setstate__(self,parm)

	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 1.5
			me.BlockingPropensity = 0.7
			me.AttackList = BCopy.deepcopy(Super_DwfAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			
	



def ExtraAnmForSuper_Dwf ():

	Sdwf=Bladex.GetCharType("Dwarf_N","Dwf_N")
	
	# Great Hammer
	Bladex.AddBipedAction("Dwarf_N","Dwf_g_18","Dwf_g_18",0.0,1.0,0)
	Sdwf.AddAttack("GM13_1H","Dwf_g_18")
	Sdwf.AttackWindow("Dwf_g_18",0.417,0.768,"GM13_1H_Window")
	Sdwf.AssignTrail("GM13_1H","","EstelaRoja1")
	Sdwf.AddLevels("Dwf_g_18",11,40)
	Sdwf.AddEnergyLevel("Dwf_g_18", 0)
	
	#  club
 	Bladex.AddBipedAction("Dwarf_N","Dwf_g_14","Dwf_g_14",0.0,1.0,0)
	Sdwf.AddAttack("GM30_1H","Dwf_g_14")
 	Sdwf.AttackWindow("Dwf_g_14",0.001,0.900,"GM30_1H_Window")
 	Sdwf.AssignTrail("GM30_1H","","EstelaRoja1")
 	Sdwf.AddLevels("Dwf_g_14",16,40)
	Sdwf.AddEnergyLevel("Dwf_g_14", 0)
			
			
			
Super_DwfAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

           # dodges:
            [Combat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],

            # basic attacks
	    [Combat.ATTACK, 0.1, ("GI_1H",),            0.0, 1800.0, 2500.0, 0.35], # Light Attack 
	    [Combat.ATTACK, 0.1, ("GM12_1H",),          0.0, 1800.0, 2500.0, 0.35], # Light High Attack 
	    [Combat.ATTACK, 0.1, ("GM18_1H",),          0.0, 1800.0, 2500.0, 0.35], # Light Low Attack 
	    [Combat.ATTACK, 0.1, ("GM16_1H",),          0.0, 1800.0, 2500.0, 0.35], # Light Left Attack 
	    [Combat.ATTACK, 0.1, ("GM14_1H",),          0.0, 1800.0, 2500.0, 0.35], # Light Right Attack 
            
            [Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            
            [Combat.MOVE,   0.15, Combat.TempMoveInProc,      3000.0,  7000.0, 9000.0, 0.35, 1],
            [Combat.MOVE,   0.05, Combat.TempMoveOutProc,     3000.0,  3000.0, 7000.0, 0.35, 1],

            [Combat.ATTACK, 0.12, ("GM30_1H",), 	  1200.0, 1600.0, 2500.0, 0.35],        #Nutcracker
            [Combat.ATTACK, 0.12, ("GM13_1H",), 	  1200.0, 1600.0, 2500.0, 0.35],        #Earthquake
]

####### End Enemy Dwarf


class Super_Knt (Enm_Def.NPCPerson):
	def __init__(self, me):
		# base class init
		Enm_Def.NPCPerson.__init__(self, me)
		#print "Personage Creado",me.Name,self.changed_func

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
	
		
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosCaballero(EntityName)
		Reference.EnemiesScorerData[self.Name]=("KnightIcon","Knt")
		

	# Functions for loading and saving state
	def __getstate__(self):	
		#print "Changed Funcs",self.changed_func
		
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			print "ERROR: Super_Knt.__getstate__(): Base class version differs."
			return NPCPerson_state
		NPCPerson_state[1]["Super_Knt"]=()
		return NPCPerson_state
	
	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Enm_Def.NPCPerson.__setstate__(self,parm)

	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 1.5
			me.BlockingPropensity = 0.7
			me.AttackList = BCopy.deepcopy(Super_KntAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00

			
def ExtraAnmForSuper_Knt ():

	Sknt=Bladex.GetCharType("Knight_N","Kgt")

	#  Espada romana
	Bladex.AddBipedAction("Knight_N","g_27kata_new","Kgt_g_27kata_new",0.0,1.0,0)
	Sknt.AddAttack("GM35_1H","Kgt_g_27kata_new")
	Sknt.AttackWindow("Kgt_g_27kata_new",0.427,0.670,"GM35_1H_Window")
	Sknt.AssignTrail("GM35_1H","","EstelaRoja1")
	Sknt.AddLevels("Kgt_g_27kata_new",7,40)
	Sknt.AddEnergyLevel("Kgt_g_27kata_new", 0)

	#  Espada elfica
	#Bladex.AddBipedAction("Knight_N","g_32_5_3new","Kgt_g_32_5_3new",0.0,1.0,0)
	#Sknt.AddAttack("GM34_1H","Kgt_g_32_5_3new")
	#Sknt.AttackWindow("Kgt_g_32_5_3new",0.508,0.706,"GM34_1H_Window")
	#Sknt.AssignTrail("GM34_1H","","EstelaRoja1")
	#Sknt.AddLevels("Kgt_g_32_5_3new",8,40)
	#Sknt.AddEnergyLevel("Kgt_g_32_5_3new", 0)

	#  Espada curva
	Bladex.AddBipedAction("Knight_N","g_sb25_new","Kgt_g_sb25_new",0.0,1.0,0)
	Sknt.AddAttack("GM5_1H","Kgt_g_sb25_new")
	Sknt.AttackWindow("Kgt_g_sb25_new",0.472,0.626,"GM5_1H_Window")
	Sknt.AssignTrail("GM5_1H","","EstelaRoja1")
	Sknt.AddLevels("Kgt_g_sb25_new",5,40)
	Sknt.AddEnergyLevel("Kgt_g_sb25_new", 0)
	
	#   Hawk Attack
	
	Bladex.AddBipedAction("Knight_N","g_19_bs1_new","Kgt_g_19_bs1_new",0.0,1.0,0)
	Sknt.AddAttack("GM7_1H","Kgt_g_19_bs1_new")
	Sknt.AttackWindow("Kgt_g_19_bs1_new",0.548,0.694,"GM7_1H_Window")
	Sknt.AssignTrail("GM7_1H","","EstelaAmarilla1")
	Sknt.AddLevels("Kgt_g_19_bs1_new",5,40)
	Sknt.AddEnergyLevel("Kgt_g_19_bs1_new", 0)
	Bladex.SetAnimationFactor("Kgt_g_19_bs1_new",4)
	
	
	
Super_KntAttackData = [
	# inner zone blocks:
	[Combat.BLOCK,  0.20, "tr",                 750.0, 1500.0, 3500.0, 0.50],
	[Combat.BLOCK,  0.20, "tl",                 750.0, 1500.0, 3500.0, 0.50],
	[Combat.BLOCK,  0.20, "tb",                 750.0, 1500.0, 3500.0, 0.50],
    	[Combat.BLOCK,  0.40, "tf",                 750.0, 1500.0, 3500.0, 0.50],

    	# outer zone blocks:
    	[Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
    	[Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
    	[Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
    	[Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

	# dodges
    	[Combat.DODGE,  0.15, "d_r",                0.0, 1200.0, 2800.0, 0.35],
    	[Combat.DODGE,  0.15, "d_l",                0.0, 1200.0, 2800.0, 0.35],
    	[Combat.DODGE,  0.10, "d_b",                0.0, 1200.0, 2800.0, 0.35],

	# basic attacks
	[Combat.ATTACK, 0.05, ("GI_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light Attack 
	[Combat.ATTACK, 0.05, ("GM1_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light High Attack 
	[Combat.ATTACK, 0.05, ("GM8_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light Low Attack 
	[Combat.ATTACK, 0.05, ("GM6_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light Left Attack 
	[Combat.ATTACK, 0.05, ("GM3_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light Right Attack 

    	# inner zone moves:
    	[Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
    	[Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
    	[Combat.MOVE,   0.15, "tb",                   0.0, 2000.0, 5000.0, 0.35],
    	[Combat.MOVE,   0.10, "tf",                   0.0, 2000.0, 5000.0, 0.35],
    	[Combat.ATTACK, 0.12, ("GM17_1H",), 	  1200.0, 1600.0, 2500.0, 0.35],        #hawk attack
    	[Combat.ATTACK, 0.12, ("GM5_1H",), 	  1200.0, 1600.0, 2500.0, 0.35],        #soul of hounour
    	[Combat.ATTACK, 0.12, ("GM35_1H",), 	  1200.0, 1600.0, 2500.0, 0.35],        #righteous anger
    	
    	[Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
    	[Combat.MOVE,   0.15, Combat.TempMoveInProc,      3000.0,  7000.0, 9000.0, 0.35, 1],
        [Combat.MOVE,   0.05, Combat.TempMoveOutProc,     3000.0,  3000.0, 7000.0, 0.35, 1],
]



		
		
#######################################################################################################################################################

