import Bladex
from math import pow
import Reference
import EnemyTypes
import Sparks
import Actions
import pocimac
import Breakings
import ItemTypes
import darfuncs
import AuxFuncs
import LevelFuncs
import Torchs
import AniSound
import pdb
import math
import Enm_Def
import os


import AllyOrkTypes

import EnemyCharTypes



#### Goodies

ally1=Bladex.CreateEntity("Buddy1","Ork",-129078.64561,-7184.91153637,-27309.2238598, "Person")
ally1.Scale=1.0
ally1.Angle=6
ally1.Level=11
ally1.Data=AllyOrkTypes.AllyOrk(ally1)
o=Bladex.CreateEntity ("Buddy1WP", "Hacha", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Buddy1", "Buddy1WP")
ally1.Data.PutOnHelmet("Buddy1")


ally2=Bladex.CreateEntity("Buddy2","Ork",-140724.810469,-6284.91185901,-33572.4351813, "Person")
ally2.Scale=1.0
ally2.Angle=5.4
ally2.Level=11
ally2.Data=AllyOrkTypes.AllyOrk(ally2)
o=Bladex.CreateEntity ("Buddy2WP", "Orksword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Buddy2", "Buddy2WP")
o=Bladex.CreateEntity ("Buddy2SH", "Escudo7", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Buddy2SH")
Actions.TakeObject("Buddy2", "Buddy2SH")
ally2.Data.PutOnHelmet("Buddy2")


ally3=Bladex.CreateEntity("Buddy3","Ork",-114457.067576,-7184.91185901,-31913.5580064, "Person")
ally3.Scale=1.0
ally3.Angle=4.48
ally3.Level=9
ally3.Data=AllyOrkTypes.AllyOrk(ally3)
o=Bladex.CreateEntity ("Buddy3WP", "Dagesse", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Buddy3", "Buddy3WP")


ally4=Bladex.CreateEntity("Buddy4","Ork",-117241.245412,-7184.90197383,-29767.2874222, "Person")
ally4.Scale=1.0
ally4.Angle=1.83
ally4.Level=9
ally4.Data=AllyOrkTypes.AllyOrk(ally4)
if os.path.exists ("../../Config/proclub1.cfg"):
	o=Bladex.CreateEntity ("Buddy4WP", "ProClub1", 0,0,0, "Weapon")
else:
	o=Bladex.CreateEntity ("Buddy4WP", "Cazo", 0,0,0, "Weapon")
	print"ProClub1 not loaded yet"
ally4.Data.PutOnHelmet("Buddy4")
	
Actions.TakeObject("Buddy4", "Buddy4WP")




ally5=Bladex.CreateEntity("Buddy5","Great_Ork",-130204.930146,-7287.66520785,-23265.1124411, "Person")
ally5.Scale=1.0
ally5.Angle=4.3
ally5.Level=11
ally5.Data=AllyOrkTypes.AllyOrk(ally5)
if os.path.exists ("../../Config/urukblade4.cfg"):
	o=Bladex.CreateEntity ("Buddy5WP", "UrukBlade4", 0,0,0, "Weapon")
else:
	o=Bladex.CreateEntity ("Buddy5WP", "Cazo", 0,0,0, "Weapon")
	print"ProClub1 not loaded yet"

o=Bladex.CreateEntity ("Buddy5SH", "Escudo9", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Buddy5SH")

Actions.TakeObject("Buddy5", "Buddy5WP")
Actions.TakeObject("Buddy5", "Buddy5SH")




ally6=Bladex.CreateEntity("Buddy6","Great_Ork",-137174.240199,-6387.66520259,-33662.6262306, "Person")
ally6.Scale=1.0
ally6.Angle=4.17973262265
ally6.Level=13
ally6.Data=AllyOrkTypes.AllyOrk(ally6)

if os.path.exists ("../../Config/urukblade4.cfg"):
	o=Bladex.CreateEntity ("Buddy6WP", "UrukBlade4", 0,0,0, "Weapon")
else:
	o=Bladex.CreateEntity ("Buddy6WP", "Cazo", 0,0,0, "Weapon")
	print"UrukBlade4 not loaded yet"

o=Bladex.CreateEntity ("Buddy6SH", "Escudo6", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Buddy6SH")

Actions.TakeObject("Buddy6", "Buddy6WP")
Actions.TakeObject("Buddy6", "Buddy6SH")



min1=Bladex.CreateEntity("Min1","Minotaur",-82303.3503275,-11608.0044669,-64946.7482554, "Person")
min1.Scale=1.0
min1.Angle=0.9
min1.Level=8
min1.Data=AllyOrkTypes.FriendlyMinotaur(min1)
min1.Blind=1
min1.Deaf=1

if os.path.exists ("../../Config/gorgonhammer5.cfg"):
	o=Bladex.CreateEntity ("Min1WP", "GorgonHammer5", 0,0,0, "Weapon")
else:
	o=Bladex.CreateEntity ("Min1WP", "Hachacarnicero", 0,0,0, "Weapon")

Actions.TakeObject("Min1", "Min1WP")


########################################################################################################
#### Baddies

knt1=Bladex.CreateEntity("Knight1","Knight_Traitor",-89774,-10685,-51985, "Person")
knt1.Scale=1.0
knt1.Angle=2.85
knt1.Level=10
EnemyTypes.EnemyDefaultFuncs(knt1)
knt1.SetMesh("Mortimer")
o=Bladex.CreateEntity ("Knight1WP", "Hacha3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight1", "Knight1WP")
o=Bladex.CreateEntity ("Knight1SH", "Escudo5", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Knight1SH")
Actions.TakeObject("Knight1", "Knight1SH")


knt2=Bladex.CreateEntity("Knight2","Knight_Traitor",-87374.1993543,-10649.288825,-52485.5095349, "Person")
knt2.Scale=1.0
knt2.Angle=1.21198406784
knt2.Level=11
knt2.SetMesh("Mortimer")
EnemyTypes.EnemyDefaultFuncs(knt2)
o=Bladex.CreateEntity ("Knight2WP", "Espadaromana", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight2", "Knight2WP")




dwf1=Bladex.CreateEntity("Dwarf1","Dwarf_N",-43460.2019128,-12149.2888251,-25987.3461805, "Person")
dwf1.Scale=1.0
dwf1.Angle=5.52
dwf1.Level=10
dwf1.Data=EnemyCharTypes.Super_Dwf(dwf1)

o=Bladex.CreateEntity ("Dwarf1WP", "Garropin", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Dwarf1", "Dwarf1WP")

o=Bladex.CreateEntity ("Dwarf1SH", "Escudo5", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Dwarf1SH")
Actions.TakeObject("Dwarf1", "Dwarf1SH")



dwf2=Bladex.CreateEntity("Dwarf2","Dwarf_N",-45260.2019128,-12149.288825,-15487.3461805, "Person")
dwf2.Scale=1.0
dwf2.Angle=1.2
dwf2.Level=10
dwf2.Data=EnemyCharTypes.Super_Dwf(dwf2)
dwf2.SetMesh("DwfSkin2")

o=Bladex.CreateEntity ("Dwarf2WP", "Martillo", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Dwarf2", "Dwarf2WP")

o=Bladex.CreateEntity ("Dwarf2SH", "Escudo3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Dwarf2SH")
Actions.TakeObject("Dwarf2", "Dwarf2SH")



dwf3=Bladex.CreateEntity("Dwarf3","Dwarf_N",14796,-21949,52934, "Person")
dwf3.Scale=1.0
dwf3.Angle=1.2
dwf3.Level=10
dwf3.Data=EnemyCharTypes.Super_Dwf(dwf3)
dwf3.SetMesh("Enano4")

o=Bladex.CreateEntity ("Dwarf3WP", "Martillo", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Dwarf3", "Dwarf3WP")

o=Bladex.CreateEntity ("Dwarf3SH", "Escudo3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Dwarf3SH")
Actions.TakeObject("Dwarf3", "Dwarf3SH")



dwf4=Bladex.CreateEntity("Dwarf4","Dwarf_N",14296,-21949,54934, "Person")
dwf4.Scale=1.0
dwf4.Angle=1.2
dwf4.Level=10
dwf4.Data=EnemyCharTypes.Super_Dwf(dwf4)
dwf4.SetMesh("Enano2")

o=Bladex.CreateEntity ("Dwarf4WP", "Martillo2", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Dwarf4", "Dwarf4WP")




tr1=Bladex.CreateEntity("Troll1","Troll_Dark",-2976.25680432,-10283.6827446,57940.2020134, "Person")
tr1.Scale=1.0
tr1.Angle=3.97
tr1.Level=9
EnemyTypes.EnemyDefaultFuncs(tr1)

o=Bladex.CreateEntity ("Troll1WP", "Hacha", 0,0,0, "Weapon")
o.Scale=1.4
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Troll1", "Troll1WP")



tr2=Bladex.CreateEntity("Troll2","Troll_Dark",-22186.7400382,-10583.6827448,63556.5791788, "Person")
tr2.Scale=1.0
tr2.Angle=3.87
tr2.Level=9
EnemyTypes.EnemyDefaultFuncs(tr2)

o=Bladex.CreateEntity ("Troll2WP", "Hachacarnicero", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Troll2", "Troll2WP")



knt3=Bladex.CreateEntity("Knight3","Knight_Traitor",-74379, -10108, 76407, "Person")
knt3.Scale=1.0
knt3.Angle=2.85
knt3.Level=10
EnemyTypes.EnemyDefaultFuncs(knt3)
knt3.SetMesh("Mortimer")
o=Bladex.CreateEntity ("Knight3WP", "Hacha4", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight3", "Knight3WP")
o=Bladex.CreateEntity ("Knight3SH", "Escudo5", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Knight3SH")
Actions.TakeObject("Knight3", "Knight3SH")


knt4=Bladex.CreateEntity("Knight4","Knight_Traitor",-109521, -6391, 89920, "Person")
knt4.Scale=1.0
knt4.Angle=2.85
knt4.Level=10
EnemyTypes.EnemyDefaultFuncs(knt4)
knt4.SetMesh("Mortimer")
o=Bladex.CreateEntity ("Knight4WP", "Gladius", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight4", "Knight4WP")
o=Bladex.CreateEntity ("Knight4SH", "Escudo5", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Knight4SH")
Actions.TakeObject("Knight4", "Knight4SH")


knt5=Bladex.CreateEntity("Knight5","Knight_Traitor",-114593, -6213, 90412, "Person")
knt5.Scale=1.0
knt5.Angle=2.85
knt5.Level=10
EnemyTypes.EnemyDefaultFuncs(knt5)
knt5.SetMesh("Mortimer")
o=Bladex.CreateEntity ("Knight5WP", "Espadaromana", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight5", "Knight5WP")
o=Bladex.CreateEntity ("Knight5SH", "Escudo5", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Knight5SH")
Actions.TakeObject("Knight5", "Knight5SH")






dwf5=Bladex.CreateEntity("Dwarf5","Dwarf_N",-121149, -24278, 149581, "Person")
dwf5.Scale=1.0
dwf5.Angle=1.2
dwf5.Level=10
dwf5.Data=EnemyCharTypes.Super_Dwf(dwf5)
dwf5.SetMesh("Enano3")

o=Bladex.CreateEntity ("Dwarf5WP", "Garropin", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Dwarf5", "Dwarf5WP")





dwf6=Bladex.CreateEntity("Dwarf6","Dwarf_N",-124251, -24233, 153206, "Person")
dwf6.Scale=1.0
dwf6.Angle=1.2
dwf6.Level=10
dwf6.Data=EnemyCharTypes.Super_Dwf(dwf6)
dwf6.SetMesh("DwfSkin1")

o=Bladex.CreateEntity ("Dwarf6WP", "Hacha3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Dwarf6", "Dwarf6WP")


StartMusicAL()
