
import Bladex
import math
import DefAnims
##########################
# Create New Biped Data  #
##########################


    ####################
    #                  #
    # Dark Orc         #
    #                  #
    ####################
    
    
    
import DarkOrkAnm_def
DarkOrkAnm_def.InitDarkOrk()    
    

    	


dok=Bladex.GetCharType("Dark_Ork","Dok")
dok.IntName="Dok" 


dok.TurnSpeed=4.5
dok.Jcost=2700
dok.MaxFall=4000
dok.DieFall=14000
dok.MaxStair=505
dok.Fov=math.pi/1.2
dok.MaxGrab=3500.0
dok.MedGrab=2500.0
dok.Min2Grab=1500.0

dok.MinTake=-500.0		# Min height above floor barbarian will take
dok.MaxTake1=250.0	# Max height above floor for Take1 Anim
dok.MaxTake2=550.0	# Max height above floor for Take2 Anim
dok.MaxTake3=1300.0	# Max height above floor for Take3 Anim
dok.MaxTake4=1900.0	# Max height above floor for Take4 Anim
dok.MaxTake5=3000.0	# Max height above floor for Take5 Anim
dok.Reach=2000.0	# Max distance from dok centre to obj centre to take

dok.MovFrwdSpeedInStrafe=1000  #Forwards speed when in strafe(combat mode only)
dok.MovBkwdSpeedInStrafe=1200  # 1000 #Idem backwards

dok.MaxCombatDist=16000        # 8000
dok.DistStop=2000.0
dok.DistStop2=5000.0
dok.MaxSeeDist=50000           #30000

dok.AddRouteAnim="Tkn_wai_01"
dok.AddRouteAnim="Tkn_wai_02"


#dok.NaturalWeapons=1  # model does not have damage groups :(

dok.SetNCDSpheres(2)  #Numero de esferas en el modelo de colisiones
dok.SetCDSphere(0,170.0,350.0)  #(numero de la espera, altura mm, radio mm)
dok.SetCDSphere(1,-150.0,500.0)  #(numero de la espera, altura mm, radio mm)

###############################################################################
    	

Bladex.CreateBipedData("Dok","Dark_Ork")

######################################################
# Comment the next section when changes are complete #
######################################################
#import os

#try:
#	os.remove("..\\..\\AnmPak\\Dok.dat")
#except:
#	pass
#######################################################
exitsPak=Bladex.LoadAnmRaceData("../../AnmPak/Dok.dat")

import NUDarkOrkAnimationSet
NUDarkOrkAnimationSet.LoadDarkOrkAnimationSet("Dok")
import NUDarkOrkBAct
import LinkTables
LinkTables.LinkMe("Dok")
import NUDarkOrkCombos
import NuAnmFact
NuAnmFact.AnmFactDok()



if not exitsPak:
	Bladex.SaveAnmRaceData("../../AnmPak/Dok.dat","Dok")
	
print"New Dok Data Set"
	
	
	
	
	
#try:
#	if dir(DefAnims).count("Dark_Ork"):
#		DefAnims.Dark_Ork()
#except NameError:
#	pass
	
		
Bladex.AddFloorCTolerance("slip",10)

import BBLib
try:
	BBLib.LoadResourceToMemory(BBLib.B_CID_BMP, "DarkOrcIcon")	
except:
	pass
	
	