
import Bladex
import math
##########################
# Create New Biped Data  #
##########################


    ####################
    #                  #
    # Chief Ork        #
    #                  #
    ####################
    
    
    
    
    
import ChiefOrkAnm_def
ChiefOrkAnm_def.InitCrk()    	
    	
    

crk=Bladex.GetCharType("Chief_Ork","Crk")
crk.IntName="Crk" 


crk.TurnSpeed=4.5
crk.Jcost=2700
crk.MaxFall=4000
crk.DieFall=14000
crk.MaxStair=405
crk.Fov=math.pi/1.2
crk.MaxGrab=3500.0
crk.MedGrab=2500.0
crk.Min2Grab=1500.0

crk.MinTake=-500.0	# Min height above floor barbarian will take
crk.MaxTake1=250.0	# Max height above floor for Take1 Anim
crk.MaxTake2=550.0	# Max height above floor for Take2 Anim
crk.MaxTake3=1300.0	# Max height above floor for Take3 Anim
crk.MaxTake4=1900.0	# Max height above floor for Take4 Anim
crk.MaxTake5=3000.0	# Max height above floor for Take5 Anim
crk.Reach=2000.0	# Max distance from ork centre to obj centre to take

crk.MovFrwdSpeedInStrafe=1000  #Forwards speed when in strafe(combat mode only)
crk.MovBkwdSpeedInStrafe=1400  # 1000 #Idem backwards

crk.MaxCombatDist=16000        # 8000
crk.DistStop=2000.0
crk.DistStop2=5000.0
crk.MaxSeeDist=50000           #30000

crk.AddRouteAnim="Tkn_wai_01"
crk.AddRouteAnim="Tkn_wai_02"

crk.SetNCDSpheres(1)
crk.SetCDSphere(0,-140.0,640.0)  #(numero de la espgok.SetCDSphere(1,-200.0,580.0)era, altura mm, radio mm)



    	
    	
###############################################################################
    	
    	
def ChiefOrkWhenFirst():

	Bladex.CreateBipedData("Crk","Chief_Ork")
	
	######################################################
	# Comment the next section when changes are complete #
	######################################################
	#import os
	#
	#try:
	#	os.remove("..\\..\\AnmPak\\Crk.dat")
	#except:
	#	pass
	######################################################

	exitsPak=Bladex.LoadAnmRaceData("../../AnmPak/Crk.dat")

	import NUChiefOrkAnimationSet
	NUChiefOrkAnimationSet.LoadChiefOrkAnimationSet("Crk")
	import NUChiefOrkBAct
	import LinkTables
	LinkTables.LinkMe("Crk")
	import NUChiefOrkCombos

	import NuAnmFact
	NuAnmFact.AnmFactChiefOrk()



	if not exitsPak:
		Bladex.SaveAnmRaceData("../../AnmPak/Crk.dat","Crk")
	
	Bladex.AddFloorCTolerance("slip",10)
	
	print"New Chief Ork Data Set"
	
	
	
race=Bladex.GetCharType("Chief_Ork","Crk")
race.OnFirst=ChiefOrkWhenFirst

	
	
	
#if dir(DefAnims).count("Ork"):
#	DefAnims.Ork()
#
#import BBLib
#BBLib.LoadResourceToMemory(BBLib.B_CID_BMP, "OrcIcon")	
