
import Bladex
import math
##########################
# Create New Biped Data  #
##########################


    ####################
    #                  #
    # Ork              #
    #                  #
    ####################
    
    
    
    
    
import OrkAnm_def
OrkAnm_def.InitOrk()    	
    	
    

orx=Bladex.GetCharType("Orx","Orx")
orx.IntName="Orx" 


orx.TurnSpeed=4.5
orx.Jcost=2700
orx.MaxFall=4000
orx.DieFall=14000
orx.MaxStair=505
orx.Fov=math.pi/1.2
orx.MaxGrab=3500.0
orx.MedGrab=2500.0
orx.Min2Grab=1500.0

orx.MinTake=-500.0		# Min height above floor barbarian will take
orx.MaxTake1=250.0	# Max height above floor for Take1 Anim
orx.MaxTake2=550.0	# Max height above floor for Take2 Anim
orx.MaxTake3=1300.0	# Max height above floor for Take3 Anim
orx.MaxTake4=1900.0	# Max height above floor for Take4 Anim
orx.MaxTake5=3000.0	# Max height above floor for Take5 Anim
orx.Reach=2000.0	# Max distance from orx centre to obj centre to take

orx.MovFrwdSpeedInStrafe=1000  #Forwards speed when in strafe(combat mode only)
orx.MovBkwdSpeedInStrafe=1200  # 1000 #Idem backwards

orx.MaxCombatDist=16000        # 8000
orx.DistStop=2000.0
orx.DistStop2=5000.0
orx.MaxSeeDist=50000           #30000

orx.AddRouteAnim="Tkn_wai_01"
orx.AddRouteAnim="Tkn_wai_02"


#orx.NaturalWeapons=1  # model does not have damage groups :(

orx.SetNCDSpheres(2)  #Numero de esferas en el modelo de colisiones
orx.SetCDSphere(0,170.0,350.0)  #(numero de la espera, altura mm, radio mm)
orx.SetCDSphere(1,-150.0,500.0)  #(numero de la espera, altura mm, radio mm)

###############################################################################
    	
    	
def SoldierOrkWhenFirst():
	Bladex.CreateBipedData("Orx","Orx")

	######################################################
	# Comment the next section when changes are complete #
	######################################################
	#import os

	#try:
	#	os.remove("..\\..\\AnmPak\\Orx.dat")
	#except:
	#	pass
	######################################################
	exitsPak=Bladex.LoadAnmRaceData("../../AnmPak/Orx.dat")
	

	import NUOrkAnimationSet
	NUOrkAnimationSet.LoadOrkAnimationSet("Orx")
	import NUOrkBAct
	import LinkTables
	LinkTables.LinkMe("Orx")
	import NUOrkCombos

	import NuAnmFact##########################
	NuAnmFact.AnmFactOrk()####################

	if not exitsPak:
		Bladex.SaveAnmRaceData("../../AnmPak/Orx.dat","Orx")
	
	Bladex.AddFloorCTolerance("slip",10)
	
	print"New Ork Data Set"
	
	
	
race=Bladex.GetCharType("Orx","Orx")
race.OnFirst=SoldierOrkWhenFirst
	


import BBLib
try:
	BBLib.LoadResourceToMemory(BBLib.B_CID_BMP, "OrcIcon")	
except:
	pass